/**
 * @author Maxim Degtyarev <mdegtyarev@gmail.com>
 */
import java.io.*;
import java.util.*;

public class ProblemC {

    private final Scanner input;
    private final PrintStream output;


	private boolean isPalindrome(long number) {
		String numberAsString = Long.toString(number);

		int len = numberAsString.length();

		for(int i = 0; i < len; i++) {
			if (numberAsString.charAt(i) != numberAsString.charAt(len - i - 1))
				return false;
		}

		return true;
	}

    private String solveCase() {
		long low = input.nextLong();
		long high = input.nextLong();

		long lowSqrt = (long)Math.sqrt(low);
		long highSqrt = (long)Math.sqrt(high);

		int count = 0;

		for(long i = lowSqrt; i <= highSqrt; i++) {
//			if (isPalindrome(i)&&isPalindrome(i*i)) count++;
			if (isPalindrome(i)) {
				long square = i*i;
				if ((square >= low)&&(square <= high)&&isPalindrome(square)) {
					count++;
				}
			}
		}

		return Integer.toString(count);
    }

    private void invoke() {
        int caseCount = input.nextInt();

        String rest = input.nextLine();

        assert rest.length() == 0 : rest;

        String result;
        for(int caseNumber = 1; caseNumber <= caseCount; caseNumber++) {
            result = solveCase();
            output.printf("Case #%d: %s\n", caseNumber, result);
        }        
    }
    
    private ProblemC(InputStream input, PrintStream output) {
        this.input = new Scanner(input);
        this.output = output;
    }     
    
    public static void main(String... args) throws FileNotFoundException {

        InputStream inputStream;
        PrintStream outputStream;
        
        if (args.length > 0) {
            
            final String inputFileName = args[0];
            final String outputFileName;
            
            if (inputFileName.endsWith(".in")) {
                outputFileName = inputFileName.substring(0, inputFileName.length() - 3) + ".out";
            } else {
                outputFileName = inputFileName + ".out";
            }

            inputStream = new FileInputStream(inputFileName);
            outputStream = new PrintStream(outputFileName);

        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        
        ProblemC instance = new ProblemC(inputStream, outputStream);
        
        instance.invoke();        
    }

}
