import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


public class LawnMover {
	int NoOfSampleCases;
	int sampleNo;
	int N,M;
	
	int lawn[][];
	int lawnT[][];
	
	BufferedReader br;
	public LawnMover() {
		sampleNo=1;
		NoOfSampleCases=0;
	}
	public void readFile(){
		try {
			br = new BufferedReader(new FileReader("Input.txt"));
			NoOfSampleCases = Integer.parseInt(br.readLine());
			do{
				readSamples();
				sampleNo++;
			}while(sampleNo<NoOfSampleCases+1);
		} catch (Exception e) {
			System.out.println("Text - File Exception : " +e);
		}
	}
	public void readSamples() throws IOException{
		
		String temp[] = br.readLine().split(" ");
		N=Integer.parseInt(temp[0].trim());
		M=Integer.parseInt(temp[1].trim());
		
		lawn = new int[N][M];
		lawnT= new int[M][N];
		for(int i=0;i<N;i++){
			String t[] = br.readLine().split(" ");
			for(int j=0;j<M;j++){
				lawn[i][j]=Integer.parseInt(t[j].trim());
				lawnT[j][i]=lawn[i][j];
			}
		}
		
		writeResult(isLawnPossible(lawn));
	}
	public void writeResult(boolean res){
		System.out.print("Case #"+sampleNo+": ");
		if(res)
			System.out.println("YES");
		else
			System.out.println("NO");
	}
	public int maxVal(int arr[]){
		int max=arr[0];
		for(int i=1;i<arr.length;i++)
			if(arr[i]>max)
				max=arr[i];
		return max;
	}
	public boolean compareArrays(int a[],int b[]){
		for(int i=0;i<a.length;i++)
			if(a[i]!=b[i])
				return false;
		return true;
	}
	public boolean isLawnPossible(int lawn[][]){
		int templawn[][] = new int[N][M];
		int templawnT[][] = new int[M][N];
		for(int i=0;i<N;i++)
			for(int j=0;j<M;j++){
				templawn[i][j]=100;
				templawnT[j][i]=100;
			}
		
		for(int i=0;i<N;i++){
			int max = maxVal(lawn[i]);
			for(int j=0;j<M;j++){
				templawn[i][j]=max;
				templawnT[j][i]=max;
			}
		}
		
		for(int i=0;i<M;i++){
			if(!compareArrays(lawnT[i], templawnT[i])){
				int max=maxVal(lawnT[i]);
				for(int j=0;j<N;j++){
					templawn[j][i]=max;
					templawnT[i][j]=max;
				}
				if(!compareArrays(lawnT[i], templawnT[i]))
					return false;
			}
		}
		
		
		return true;
	}
	public static void main(String[] args) {
		LawnMover lm = new LawnMover();
		lm.readFile();
	}

}
