import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;


public class CandySplitting {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		try {
			String inFileName = args[0];
			BufferedReader in = new BufferedReader(new FileReader(inFileName));
			BufferedWriter out = new BufferedWriter(new FileWriter(inFileName + ".out"));
			int testCases = Integer.parseInt(in.readLine());

			for (int caseNo = 1; caseNo <= testCases; ++caseNo) {
				in.readLine();
				String[] sequenceStr = in.readLine().split(" ");
				LinkedList<Integer> values = new LinkedList<Integer>();
				
				for (int i = 0; i < sequenceStr.length; ++i) {
					values.add(Integer.parseInt(sequenceStr[i]));
				}
				
				int[] bits = new int[30];
				int minElement = values.element();
				int sum = 0;
				
				for (int val : values) {
					sum += val;
					minElement = Math.min(minElement, val);
					
					for (int bit = 0; val > 0; ++bit) {
						bits[bit] += val % 2;
						val /= 2;
					}
				}
				
				boolean ok = true;
				
				for (int i = 0; i < bits.length; ++i) {
					if (bits[i] % 2 != 0) {
						ok = false;
						break;
					}
				}
				
				String caseResultStr = "Case #" + caseNo + ": " + (ok ? sum - minElement : "NO") + "\n";
				System.out.print(caseResultStr);
				out.write(caseResultStr);
				out.flush();
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
