package com.wildhemp.codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Arrays;

public class Energy {

    /**
     * @param args
     */
    public static void main(String[] args) throws Exception {
	BufferedReader dis = new BufferedReader(new InputStreamReader(
		new FileInputStream(args[0])));

	int testNum = Integer.parseInt(dis.readLine());
	for (int test = 0; test < testNum; test++) {
	    String[] strs = dis.readLine().split(" ");
	    int e = Integer.parseInt(strs[0]);
	    int r = Integer.parseInt(strs[1]);
	    int n = Integer.parseInt(strs[2]);
	    
	    strs = dis.readLine().split(" ");
	    Task[] tasks = new Task[n];
	    int[] vals = new int[n];
	    for (int idx = 0; idx < n; idx ++) {
		vals[idx] = Integer.parseInt(strs[idx]);
		tasks[idx] = new Task(vals[idx], idx);
	    }
	    
	    Arrays.sort(tasks);

	    int[] maxUsable = new int[n];
	    int[] shouldRemain = new int[n];
	    Arrays.fill(maxUsable, Integer.MAX_VALUE);
	    
	    int r1 = 0;
	    for (Task task: tasks) {
		maxUsable[task.index] = Math.min(e, maxUsable[task.index]);
		r1 = r;
		for (int idx = task.index - 1; idx >= 0 && vals[task.index] > vals[idx] && r1 <= e; idx --, r1 += r) { 
		    maxUsable[idx] = Math.min(r1, maxUsable[idx]);
		    shouldRemain[idx] = Math.max(e - r1, shouldRemain[idx]);
		}
		r1 = r;
		for (int idx = task.index + 1; idx < n && vals[task.index] >= vals[idx] && r1 <= e; idx ++, r1 += r) {
		    maxUsable[idx] = shouldRemain[task.index] - shouldRemain[idx] + r1; 
		}
	    }
	    
	    long gain = 0;
	    for (int idx = 0; idx < n; idx ++) {
		gain += vals[idx] * maxUsable[idx];
	    }
	    
	    System.out.println("Case #" + (test + 1) + ": " + gain);
	}
    }
    
    private static class Task implements Comparable {
	int value;
	int index;
	
	public Task(int value, int index) {
	    this.value = value;
	    this.index = index;
	}

	@Override
	public int compareTo(Object o) {
	    return ((Task) o).value - value;
	}
	
	@Override
	public String toString() {
	    return value + ":" + index;
	}
    }

}
