import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class RPI 
{
  	public static PrintStream output;

	public static double wp( String wins, int ign )
	{
		int i;
		double wp = 0.0;
		double count = wins.length();
		if( ign >= 0 )
			count--;
		for( i=0; i<wins.length(); i++ )
		{
			if( i == ign )
				continue;
			if( wins.charAt(i) == '1' )
			{
				wp++;
			}
			if( wins.charAt(i) == '.' )
			{
				count--;	/* didn't play */
			}
		}
		return wp / count;
	}
	
  	public static void main(String[] args) throws FileNotFoundException 
  	{
		FileInputStream inputStream = new FileInputStream(new File(args[0]));
    	output = new PrintStream(new File(args[1]));
    	Scanner scanner = new Scanner(inputStream);
    	int numberOfTests = scanner.nextInt();
    	for (int i = 1; i <= numberOfTests; i++) 
	 	{
			int teams = scanner.nextInt();
			double[] wp = new double[teams];
			double[][] owp = new double[teams][teams];
			double[] oowp = new double[teams];
			double[] rpi = new double[teams];
			String[] wins = new String[teams];
			scanner.nextLine();
			for( int j=0; j<teams; j++ )
			{
				wins[j] = scanner.nextLine();
				System.out.println( wins[j] );
				wp[j] = wp(wins[j], -1);
			}
			/* owp */
			for( int j=0; j<teams; j++ )
			{
				for( int k=0; k<teams; k++ )
				{
					owp[j][k] = wp(wins[k], j);
				}
				owp[j][j] = 0.0;
				double div = 0;
				for( int k=0; k<teams; k++ )
				{
					if( k==j ) continue;
					if( wins[j].charAt(k) != '.' )
					{
						owp[j][j] += owp[j][k];
						div++;
					} 
				}
				owp[j][j] /= div;
			}
			/* oowp */
			output.println("Case #" + i + ":");
			for( int j=0; j<teams; j++ )
			{
				oowp[j] = 0.0;
				double div = 0.0;
				for( int k=0; k<teams; k++ )
				{	
					if( j==k ) continue;
					if( wins[j].charAt(k) != '.' )
					{
						oowp[j] += owp[k][k];
						div++;
					}
				}
				oowp[j] /= div;
				rpi[j] = 0.25 * wp[j] + 0.50 * owp[j][j] + 0.25 * oowp[j];
				output.println(rpi[j]);
			}
		}
	}
}