package harmony;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;

public class Harmony
{

	public static void main(String[] args) throws NumberFormatException, IOException
	{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int problems = Integer.parseInt(br.readLine());
		
		for(int prob = 0;prob < problems;prob++)
		{
			int others = 0, lowest, highest = 0;
			{
				String[] info = br.readLine().split(" ");
				others = Integer.parseInt(info[0]);
				lowest = Integer.parseInt(info[1]);
				highest = Integer.parseInt(info[2]);
			}
			
			int[] freqs = new int[others];
			{
				String[] sFreqs = br.readLine().split(" ");
				for(int i = 0;i < others;i++)
					freqs[i] = Integer.parseInt(sFreqs[i]);
			}
			
			Arrays.sort(freqs);
			
			int lowestHarm = -1;
			
			int[] range = new int[highest - lowest + 1];
			
			for(int freq : freqs)
			{
				if(freq <= highest)
				{
					int inc = freq;
					int sFreq = lowest - lowest % freq;
					while(sFreq <= highest)
					{
						if(sFreq >= lowest)
							range[sFreq - lowest]++;
						
						sFreq += inc;
					}
				}
				if(freq >= lowest)
				{
					int s = freq / lowest + 1;
					
					for(int i = s;i > 0;i--)
					{
						if(freq % i == 0)
						{
							int val = freq / i;
							if(val > highest)
								break;
							if(val >= lowest)
								range[val - lowest]++;
						}
					}
				}
			}
			
			for(int i = 0;i <= highest - lowest;i++)
			{
				if(range[i] == others)
				{
					lowestHarm = i + lowest;
					break;
				}
			}
			
//			{
//				for(int freq : freqs)
//				{
//					if(!isInHarmony(lowestHarm, freq))
//					{
//						int inc = lowestHarm;
//						while((!isInHarmony(prev, freq) || freq < lowest) && freq <= highest)
//						{
//							//System.out.println(freq + " " + prev + " " + highest);
//							freq += inc;
//						}
//						
//						lowestHarm = prev = freq;
//						
//						if(prev > highest)
//						{
//							possible = false;
//							break;
//						}
//					}
//				}
//				
//				if(lowestHarm == -1)
//					possible = false;
//			}
			
			System.out.print("Case #" + (prob + 1) + ": ");
			
			if(lowestHarm != -1)
			{
				System.out.println(lowestHarm);
			}
			else
				System.out.println("NO");
		}
	}
	
	public static boolean isInHarmony(int x, int y)
	{
		return x > 0 && y > 0 && Math.max(x, y) % Math.min(x, y) == 0;
	}
	
}
