import java.util.*;

public class ProblemA {
	public static void main(String... args) {
		for (DataSet dataSet : new DataSets())
			handleDataSet(dataSet);
	}

	private static void handleDataSet(DataSet dataSet) {
		System.out.println("Case #" + dataSet.number + ": " + dataSet.getResult());
	}

	public static class DataSet {
		public final long number;
		private char[][] board;

		public DataSet(long number, char[][] board) {
			this.number = number;
			this.board = board;
		}

		public String getResult() {
			for (char[] line : board) {
				Character winner = getWinner(line);
				if (winner != null)
					return winner + " won";
			}
			for (int i = 0; i < 4; ++i) {
				char[] fields = new char[4];
				for (int j = 0; j < 4; ++j) {
					fields[j] = board[j][i];
				}
				Character winner = getWinner(fields);
                                if (winner != null)
                                        return winner + " won";
			}
			char[] fields = new char[4];
                        for (int i = 0; i < 4; ++i)
				fields[i] = board[i][i];
			Character winner = getWinner(fields);
                                if (winner != null)
                                        return winner + " won";
                        for (int i = 0; i < 4; ++i)
                                fields[i] = board[i][3 - i];
                        winner = getWinner(fields);
                                if (winner != null)
                                        return winner + " won";

			for (char[] line : board)
				for (char field : line)
					if (field == '.')
						return "Game has not completed";
			return "Draw";
		}

		private Character getWinner(char... fields) {
			char candidate = '-';
			for (char field : fields)
				if (field == '.')
					return null;
				else if (candidate == '-' || candidate == 'T')
					candidate = field;
				else if (field != 'T')
					if (field != candidate)
						return null;
			return (candidate == '-') ? null : candidate;
		}
	}

	private static class DataSets implements Iterable<DataSet> {
		public Iterator<DataSet> iterator() {
			return new DataSetsIterator();
		}		
	}

	private static class DataSetsIterator implements Iterator<DataSet> {
		private final long numberOfDataSets;
		private final Scanner sc;
		private long indexOfCurrentDataSet; //zero based

		public DataSetsIterator() {
			sc = new Scanner(System.in);
			numberOfDataSets = sc.nextLong();
			sc.nextLine();
			indexOfCurrentDataSet = 0;
		}

		public boolean hasNext() {
			return indexOfCurrentDataSet < numberOfDataSets;
		}

		public DataSet next() {
			char[][] board = new char[4][];
			for (int i = 0; i < 4; ++i)
				board[i] = sc.nextLine().toCharArray();
			DataSet dataSet = new DataSet(indexOfCurrentDataSet + 1, board);
			++indexOfCurrentDataSet;
			if (hasNext())
				sc.nextLine();
			return dataSet;
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
