package mp.kotter.challenges.gcj.round2;

import java.io.IOException;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.SortedSet;
import java.util.TreeMap;
import java.util.TreeSet;

import mp.kotter.challenges.utils.Solution;

public class TicketSwapping extends Solution {

    public static final long MODULO = 1000002013L;

    public static void main(final String[] args) throws Exception {
        (new TicketSwapping()).run(args);
    }

    @Override
    protected void solve() throws Exception {
        final int T = Integer.parseInt(getInput().readLine());

        for(int c=0; c<T; c++) {
            writeCaseResult(c, solveCase());
        }
    }

    private String solveCase() throws IOException {
        long originalValue = 0;
        long decreasedValue = 0;

        final List<Integer> firstLine = readInts();
        final int n = firstLine.get(0);
        final int m = firstLine.get(1);
        final Map<Integer, Integer> in = new HashMap<Integer, Integer>();
        final Map<Integer, Integer> out = new HashMap<Integer, Integer>();
        final SortedSet<Integer> stations = new TreeSet<>();
        for(int i=0; i<m; i++) {
            final List<Integer> line = readInts();
            final int f = line.get(0);
            final int t = line.get(1);
            final int c = line.get(2);

            if (!in.containsKey(f)) {
                in.put(f, 0);
            }

            if (!out.containsKey(t)) {
                out.put(t, 0);
            }

            in.put(f, c + in.get(f));
            out.put(t, c + out.get(t));

            stations.add(f);
            stations.add(t);

            originalValue = (originalValue + (c * fare(n, f, t)) % MODULO) % MODULO;
        }

        final SortedMap<Integer, Integer> tickets = new TreeMap<>(new Comparator<Integer>() {
            @Override
            public int compare(final Integer o1, final Integer o2) {
                return o2 - o1;
            }
        });

        for(final int station : stations) {
            if (in.containsKey(station)) {
                final int goIn = in.get(station);

                if (goIn > 0) {
                    if (!tickets.containsKey(station)) {
                        tickets.put(station, 0);
                    }

                    tickets.put(station, goIn + tickets.get(station));
                }
            }

            if (out.containsKey(station)) {
                int goOut = out.get(station);

                final Map<Integer, Integer> newTickets = new HashMap<>();

                for(final int ticketIn : tickets.keySet()) {
                    final int ticketsFromIn = tickets.get(ticketIn);
                    final int goOutTicket = Math.min(goOut, ticketsFromIn);

                    if (goOutTicket == 0) {
                        break;
                    }

                    final int newTicketsFromIn = ticketsFromIn - goOutTicket;

                    newTickets.put(ticketIn, newTicketsFromIn);

                    goOut -= goOutTicket;
                    decreasedValue = (decreasedValue + (goOutTicket * fare(n, ticketIn, station)) % MODULO) % MODULO;
                }

                for(final Map.Entry<Integer, Integer> e : newTickets.entrySet()) {
                    if (e.getValue() == 0) {
                        tickets.remove(e.getKey());
                    } else {
                        tickets.put(e.getKey(), e.getValue());
                    }
                }
            }
        }

        return "" + (originalValue - decreasedValue + MODULO) % MODULO;
    }

    private long fare(final long n, final long f, final long t) {
        if (f == t) {
            return 0;
        }

        return ((n * (t - f)) % MODULO - ((t-f-1) * (t-f) / 2) % MODULO + MODULO) % MODULO;
    }

}
