import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Bullseye {
	
	private double paintRequired(long currentRadius) {
		long currentCircleArea = (long) Math.pow(currentRadius, 2);
		long greaterCircleArea = (long) Math.pow(currentRadius + 1, 2);
		
		return (greaterCircleArea - currentCircleArea);
	}
	
	private String process(String radius, String paint) {
		int numBlackRings = 0;
		double paintRemaining = (double) Long.valueOf(paint);
		long currentRadius = Long.valueOf(radius);
		double paintReq = 0;
		
		while ((paintReq = paintRequired(currentRadius)) <= paintRemaining) {
			paintRemaining -= paintReq;
			numBlackRings++;
			currentRadius += 2; // new black ring + white ring
		}
		
		if (numBlackRings == 0) {
			numBlackRings = 1;
		}
		return Integer.toString(numBlackRings);
	}

	public static void main(String[] args) {
		Bullseye b = new Bullseye();

		if (args.length == 1) {
			BufferedReader br = null;
			int numCases = 0;

			try {
				// Create the output file
				File outputFile = new File("output.out");
				if (!outputFile.exists()) {
					outputFile.createNewFile();
				}

				FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
				BufferedWriter bw = new BufferedWriter(fw);

				// Read input
				br = new BufferedReader(new FileReader(args[0]));

				// First line should contain the number of test cases
				String line = br.readLine();
				numCases = Integer.parseInt(line);

				long startTime = System.currentTimeMillis();

				// Following lines should contain test cases
				for (int i = 1; i <= numCases && line != null; i++) {
					line = br.readLine();
					String[] rangeNums = line.split(" ");
					
					String radius = rangeNums[0];
					String paint = rangeNums[1];

					String outputLine = "Case #" + i + ": "
							+ b.process(radius, paint);
					System.out.println(outputLine);
					bw.write(outputLine + "\n");
				}

				long endTime = System.currentTimeMillis();

				System.out.println("Execution time = " + (endTime - startTime));

				br.close();
				bw.close();
			} catch (IOException e) {
				System.out.println("Input file not found!");
				e.printStackTrace();
			}
		} else {
			System.err.println("Input file required for processing");
		}
	}
}
