package googlecodejam;

import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;
import java.util.StringTokenizer;

public class FileFixIt {

	private static int numMkDirs;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(new File(args[0]));
		Writer writer = new FileWriter(new File(args[1]));
		int numCases = in.nextInt();
		for (int count = 1; count <= numCases; count++) {
			numMkDirs = 0;
			int n = in.nextInt();
			int m = in.nextInt();
			int i;
			List<String> existing = new ArrayList<String>();
			String str;
			for(i = 0; i<n;i++) {
				str = in.next();
				existing.add(str);
			}
			for(i = 0; i<m;i++) {
				str = in.next();
				if(!existing.contains(str)) {
					String prefix = checkPartExisting(existing, str);
					createDirectories(existing, str, prefix);
				}
			}
			
//			System.out.println("Case #" + count + ": " + numMkDirs);
			writer.write("Case #" + count + ": " + numMkDirs + "\n");
		}
		writer.close();
	}
	
	private static void createDirectories(List<String> existing, String str, String prefix) {
		String subStr = str.substring(prefix.length());
		StringTokenizer stoken = new StringTokenizer(subStr,"/");
		String dirs = prefix;
		while(stoken.hasMoreTokens()) {
			String dirName = stoken.nextToken();
			dirs += "/" + dirName;
			existing.add(dirs);
			numMkDirs++;
		}
	}
	
	private static String checkPartExisting(List<String> existing, String str) {
		Iterator<String> itr = existing.iterator();
		int maxLength = 0;
		int index = -1;
		int i = 0;
		while(itr.hasNext()) {
			String str1 = itr.next();
			if(str.startsWith(str1)) {
				if(maxLength < str1.length()) {
					maxLength = str1.length();
					index = i; 
				}
			}
			i++;
		}
		if(index>=0)
			return existing.get(index);
		else
			return "";
	}
}
