import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;


public class Magicka {
        
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        BufferedReader reader = new BufferedReader(new FileReader(new File("c:\\magicka.in")));
        BufferedWriter writer = new BufferedWriter(new FileWriter(new File("c:\\magicka.out")));
        int testCaseCount = Integer.parseInt(reader.readLine());
        
        for(int i=0;i<testCaseCount;++i)
        {
            processTestCase(writer,i+1,reader.readLine());
        }
        
        reader.close();
        writer.close();
        
    }

    private static void processTestCase(BufferedWriter writer,int caseNumber,String inputLine) throws IOException {
        Map<String,Character> baseToNonBaseMap=new HashMap<String, Character>();
        Map<Character,Character> opposedPairMap = new HashMap<Character, Character>();
        String[] data = inputLine.split(" +");
        
        int c = Integer.parseInt(data[0]);
        int positionInData = 1;
        for(int i=0;i<c;++i)
        {
            StringBuffer tempBuffer = new StringBuffer();
            String triplet = data[positionInData++];
            String basePair = tempBuffer.append(triplet.charAt(0)).append(triplet.charAt(1)).toString();
            baseToNonBaseMap.put(basePair, triplet.charAt(2));
            tempBuffer = new StringBuffer();
            basePair = tempBuffer.append(triplet.charAt(1)).append(triplet.charAt(0)).toString();
            baseToNonBaseMap.put(basePair, triplet.charAt(2));            
        }
        
        int d = Integer.parseInt(data[positionInData++]);
        
        for(int i=0;i<d;++i)
        {
            String pair = data[positionInData++];
            
            opposedPairMap.put(pair.charAt(0), pair.charAt(1));
            opposedPairMap.put(pair.charAt(1), pair.charAt(0));
        }
        
        int n = Integer.parseInt(data[positionInData++]);
        
        String spellStr = data[positionInData];
        
        List<Character> outputList = new ArrayList<Character>();
        Map<Character,Integer> spellCount = new HashMap<Character, Integer>();  
        
        outputList.add(spellStr.charAt(0));
        spellCount.put(spellStr.charAt(0),1);
        
        char lastProcessedChar = spellStr.charAt(0);
        
        for(int i=1;i<spellStr.length();++i)
        {
            char spell = spellStr.charAt(i);
                        
            Character mergedSpell = baseToNonBaseMap.get(lastProcessedChar+""+spell);
            Character oppCharacter = opposedPairMap.get(spell);
            if(mergedSpell!=null)
            {
                outputList.remove(outputList.size()-1);
                
                spellCount.put(lastProcessedChar, spellCount.get(lastProcessedChar)-1);
                                 
                outputList.add(mergedSpell);
                
                lastProcessedChar = mergedSpell;
                
                if(spellCount.containsKey(mergedSpell))
                {
                    spellCount.put(mergedSpell, spellCount.get(mergedSpell)+1);
                }
                else
                {
                    spellCount.put(mergedSpell, 1);
                }
            }
            else if(oppCharacter!=null && spellCount.containsKey(oppCharacter) && spellCount.get(oppCharacter)>0)
            {
                outputList.clear();
                spellCount.clear();
                
                if(i!=spellStr.length()-1)
                {
                    lastProcessedChar = spellStr.charAt(i+1);
                    outputList.add(lastProcessedChar);
                    spellCount.put(lastProcessedChar, 1);
                    i++;
                }                
            }
            else
            {
                lastProcessedChar = spell;
                outputList.add(lastProcessedChar);
                if(spellCount.containsKey(spell))
                {
                    spellCount.put(spell, spellCount.get(spell)+1);
                }
                else
                {
                    spellCount.put(spell, 1);
                }                
            }
        }
        
        writer.write("Case #"+caseNumber+": "+getOutputString(outputList)+"\n");
        
    }

    private static String getOutputString(List<Character> outputList) {
        if(outputList.size()==0)
        {
            return "[]";
        }
        else
        {
            StringBuffer output = new StringBuffer();
            
            for(Character c:outputList)
            {
                output.append(c).append(", ");
            }
            return "["+output.substring(0, output.length()-2)+"]";
        }
    }

}
