import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.StringTokenizer;

public class SolverTrain {
	static Scanner in;
	static PrintStream out;

	static void solve(int caseNb) {
		int wordsNb = in.nextInt();
		in.nextLine(); 
		String wordsLine = in.nextLine();
		StringTokenizer tok = new StringTokenizer(wordsLine);
		List<String> words = new ArrayList<String>();
		for(int i=0;i<wordsNb;i++){
			String train = tok.nextToken();
			String cleanTrain = clean(train);
			if(cleanTrain == null){
				out.println("Case #" + (caseNb + 1) + ": " + 0);
				return;
			}
			words.add(cleanTrain);
		}
		
		int result = recur(words, "");
		
		out.println("Case #" + (caseNb + 1) + ": " + result);
	}
	
	
	static String clean(String word){
		StringBuilder chars = new StringBuilder();
		if(word.isEmpty()) return null;
		boolean[] usedLetter = new boolean[26];
		char previous = word.charAt(0);
		chars.append(previous);
		usedLetter[previous - 'a'] = true;
		for(int i=1;i<word.length();i++){
			char current = word.charAt(i);
			if(current != previous){
				if(usedLetter[current - 'a']){
					return null;
				}
				usedLetter[current - 'a'] = true;
				previous = current;
				chars.append(previous);
			}
		}
		return chars.toString();
	}
	
	
	static int recur(List<String> possible, String construct){
		boolean check = check(construct);
		if(possible.size() == 0){
			return check ? 1 : 0;
		}
		else{
			int sum = 0;
			for(String train : possible){
				List<String> newPossible = new ArrayList<String>(possible);
				newPossible.remove(train);
				sum+=recur(newPossible, construct + train);
				
			}
			return sum;
		}
	}
	
	static boolean check(String trains){
		if(trains.isEmpty()) return false;
		boolean[] usedLetter = new boolean[26];
		char previous = trains.charAt(0);
		usedLetter[previous - 'a'] = true;
		for(int i= 1;i<trains.length();i++){
			char current = trains.charAt(i);
			if(current != previous){
				if(usedLetter[current - 'a']){
					return false;
				}
				usedLetter[current - 'a'] = true;
				previous = current;
			}
		}
		return true;
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		Locale.setDefault(new Locale("en", "US"));
		in = new Scanner(new FileInputStream("inputs/B-small-attempt1.in"));
		out = new PrintStream("outputs/B-small-attempt1.out");

		// in = new Scanner(System.in);
//		out = System.out;

		int cases = in.nextInt();
		in.nextLine();
		for (int i = 0; i < cases; i++)
			solve(i);
	}

}