import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.TreeSet;


public class FairAndSquare {
	private static final String PATH = "src\\ressources";
	private static final String PROBLEM = "C";
	private static final String VERSION = "small-attempt0"; //large
	private static final String EXT_IN = "in";
	private static final String EXT_OUT = "out";
	
	private TreeSet<BigInteger> fairAndSquare;
	
	public void preproc(int inf, int sup) {
		fairAndSquare = new TreeSet<BigInteger>();
		for(int i = inf; i <= sup; i++) {
			if(isPaladromic(i)) {
				if(isPaladromic(BigInteger.valueOf(i).pow(2).toString())) {
					fairAndSquare.add(BigInteger.valueOf(i).pow(2));
				}
			}
		}
		System.out.println("end preproc");
	}
	
	public String solve(Scanner in) {
		return String.valueOf(fairAndSquare.subSet(in.nextBigInteger(), true, in.nextBigInteger(), true).size());
	}
	
	private boolean isPaladromic(String s) {
		int l = 0;
		int m = s.length() - 1;
		while(l <= m && s.charAt(l) == s.charAt(m)) {
			l++;
			m--;
		}
		if(l > m)
			return true;
		return false;
	}
	
	private boolean isPaladromic(int i) {
		return isPaladromic(String.valueOf(i));
	}
	
	
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(getCompletPath(EXT_IN)));
		PrintWriter out = new PrintWriter(new FileWriter(getCompletPath(EXT_OUT)));
		
		int nbTestCase = in.nextInt();
		FairAndSquare pb = new FairAndSquare();
		pb.preproc(1, (int) Math.sqrt(1000));
		for(int i = 0; i < nbTestCase; i++) {
			out.println("Case #" + (i+1) + ": " + pb.solve(in));
			out.flush();
		}
		
		in.close();
		out.close();
	}
	
	private static String getCompletPath(String ext) {
		return PATH + "\\" + PROBLEM + "-" + VERSION + "." + ext;
	}
}
