package com.google.codejam.practice2011.qualificationRound;

import com.google.codejam.abs.Problem;
import com.google.codejam.utils.files.ManejoArchivos;

import java.io.FileNotFoundException;
import java.io.IOException;


public class BotTrust extends Problem {
    public BotTrust(String name) throws FileNotFoundException, 
                                            IOException {
        super(name);
    }

    public static void main(String[] args) throws FileNotFoundException, 
                                                  IOException {
        //new BotTrust("BotTrust-Sample");
        new BotTrust("BotTrust-Small");
        //new BotTrust("BotTrust-Large");
    }

    public String execCase() throws IOException {
        String values[] = ManejoArchivos.getStrings();
        int posRobots[] = { 1, 1 }; // Orange, Blue
        int comandoActual = 1;
        int i = 0;
        for(;true;i++) {
            char nextEval = getNextEval(comandoActual, values);
            if( nextEval == '-' ) {
                break;
            }
            int nextButton[] = { getNextPosition(comandoActual, 'O', values), getNextPosition(comandoActual, 'B', values) };
            comandoActual += evalRobot(nextButton, posRobots, nextEval, 0, 'O');
            comandoActual += evalRobot(nextButton, posRobots, nextEval, 1, 'B');
        }
        
        return i + "";
    }
    private int getNextPosition(int commandoActual, char robot, String values[]) {
        for(int i=commandoActual*2-1;i<values.length;i+=2) {
            if( values[i].charAt(0) == robot ) {
                return Integer.parseInt(values[i+1]);
            }
        }
        return -1;
    }
    private char getNextEval(int commandoActual, String values[]) {
        if( values.length > commandoActual*2-1 ) {
            return values[commandoActual*2-1].charAt(0);
        }
        return '-';
    }
    private int evalRobot(int nextButton[], int posRobots[], char nextEval, int robotInt, char robotChar) {
        if( nextButton[robotInt] == -1 ) {
            System.out.println(robotInt + ": Stay");
        } else if( nextButton[robotInt] == posRobots[robotInt] ) {
            if( nextEval == robotChar ) {
                System.out.println(robotInt + ": Push " + posRobots[robotInt]);
                return 1;
            } else {
                System.out.println(robotInt + ": Stay");
            }
        } else if( nextButton[robotInt] < posRobots[robotInt] ) {
            posRobots[robotInt]--;
            System.out.println(robotInt + ": Move " + posRobots[robotInt]);
        } else {
            posRobots[robotInt]++;
            System.out.println(robotInt + ": Move " + posRobots[robotInt]);
        }
        return 0;
    }
}