/**
 *
 *
 * @author Maxim Degtyarev <mdegtyarev@gmail.com>
 *
 */

import java.io.IOException;
import java.io.RandomAccessFile;
import java.io.FileNotFoundException;
import java.util.HashSet;

public class SaveTheUniverse {

private static int processCase(RandomAccessFile f) throws IOException {
	int result = 0;
    String s = f.readLine();
	int enginesCount = Integer.parseInt(s);
	HashSet<String> allEngines = new HashSet<String>();
	
	for(int i = 0; i < enginesCount; i++) {
		allEngines.add(f.readLine());
	}

	s = f.readLine();
	int queriesCount = Integer.parseInt(s);

	HashSet<String> currEngines = (HashSet<String>)allEngines.clone();


	for(int i = 0; i < queriesCount; i++) {
		s = f.readLine();

		if (currEngines.contains(s)) {
			currEngines.remove(s);

			if (currEngines.isEmpty()) {
				currEngines = (HashSet<String>)allEngines.clone();
				currEngines.remove(s);
				result++;
			}
		}
	}

	return result;
}



public static void main(String[] args) {
	try {
		if (args.length >= 1) {
			RandomAccessFile file = new RandomAccessFile(args[0], "r");

			String s = file.readLine();
			int caseCount = Integer.parseInt(s);
	    
	    
			for (int i = 1; i <= caseCount; i++) {
				int caseResult = processCase(file);
				System.out.println("Case #" + i + ": " + caseResult);
			}
		}
	} catch (Throwable e) {
		System.out.println("WTF???\n" + e);
	}
}

}