package com.google.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;

public class PureRank {

	public void solve(File inFile, File outFile) throws IOException {		 
		BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream(inFile)));
		PrintWriter w = new PrintWriter(outFile);
		int T = Integer.parseInt(r.readLine().trim());
		
		for(int t = 0; t < T; t++) {
			String line = r.readLine().trim();
			int n = Integer.parseInt(line);
			long res = solve(n);
			w.println(String.format("Case #%d: %d", t+1, res));
		}
		w.close();
		r.close();
	}
	
	private int[] s;
	private int n;
	private int total = 0;
	
	private long solve(int n) {
		this.n = n;
		total = 0;
		s = new int[n];
		solve(2, 0);
		return total;
	}
	
	private int getIndex(int k, int c) {
		for(int i = 0; i < c; i++) {
			if (s[i] == k) {
				return i+1;
			} else if (s[i] > k) {
				return -1;
			}
		}
		return -1;
	}
	
	private boolean check(int c) {
		int cc = c;
		c = getIndex(n, cc);
		if (c == -1) {
			return false;
		}
		while(c != 1) {
			int ind = getIndex(c, cc);
			if (ind == -1) {
				return false;
			}
			c = ind;
		}
		return true;
	}
	
	private void solve(int start, int c) {		
		if (start <= n) {			
			for(int k = start; k <= n; k++) {
				s[c] = k;
				solve(k+1, c+1);
				s[c] = 0;
			}
		} else if (start > n) {			
			if (check(c)) {
//				for(int j = 0; j < c; j++) {
//					System.out.print(s[j] + " ");
//				}
//				System.out.println();
				total += 1;
				
				total = total % 100003;				
			}
		}
	}


	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		PureRank p = new PureRank();
		
		File in = new File("/temp/codejam/C-small-attempt0.in");
		File out = new File("/temp/codejam/C.out");
		p.solve(in, out);
	}

}
