import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

public class AIWar {
	private static class Location {
		public int num;
		public int distance;
		public Set<Integer> threat;

		public Location(int num, int distance, Set <Integer> threat) {
			this.num = num;
			this.distance = distance;
			this.threat = new HashSet <Integer>(threat);
		}

		public String toString() {
			return num + " " + distance + " " + threat;
		}
	}

	public static void main(String[] args) {
		Scanner inputStream = new Scanner(System.in);
		int T = Integer.parseInt(inputStream.nextLine());
		for (int i = 0; i < T; i++) {
			int P = inputStream.nextInt();
			int W = inputStream.nextInt();
			inputStream.nextLine();

			Map <Integer, Set <Integer>> neighbors = new HashMap <Integer, Set <Integer>>();
			for (int j = 0; j < P; j++) {
				neighbors.put(j, new HashSet <Integer>());
			}

			Scanner lineScanner = new Scanner(inputStream.nextLine().replaceAll(",", " "));
			for (int j = 0; j < W; j++) {
				int from = lineScanner.nextInt();
				int to = lineScanner.nextInt();

				neighbors.get(from).add(to);
				neighbors.get(to).add(from);
			}

			Location start = new Location(0, 0, neighbors.get(0));
			start.threat = new HashSet <Integer>(neighbors.get(0));
			start.threat.add(0);
			
			Queue <Location> locations = new LinkedList <Location>();
			Map <Integer, Location> locationMap = new HashMap <Integer, Location>();

			locationMap.put(0, start);
			
			locationMap.put(1, new Location(1, Integer.MAX_VALUE, new HashSet <Integer>()));
			locationMap.get(1).threat.add(1);
			
			for (int j = 2; j < P; j++) {
				locationMap.put(j, new Location(j, Integer.MAX_VALUE, neighbors.get(j)));
				locationMap.get(j).threat.add(j);
			}

			int[] distances = new int[P];
			Arrays.fill(distances, Integer.MAX_VALUE);
			distances[0] = 0;

			locations.add(start);

			while(!locations.isEmpty()) {
				Location cur = locations.poll();
				if (cur.num == 1) {
					break;
				}
				for (int j = 0; j < P; j++) {
					if (neighbors.get(j).contains(cur.num) && cur.distance + 1 <= distances[j]) {
						Location neighbor = locationMap.get(j);
						if (cur.distance + 1 < neighbor.distance) {
							neighbor.distance = distances[j] = cur.distance + 1;
							neighbor.threat = new HashSet <Integer>(cur.threat);
							if (neighbor.num != 1) {
								neighbor.threat.addAll(neighbors.get(neighbor.num));
							}
							locations.add(neighbor);
						} else {
							Set <Integer> temp = new HashSet <Integer>(cur.threat);
							if (neighbor.num != 1) {
								temp.addAll(neighbors.get(neighbor.num));
							}
							temp.add(neighbor.num);
							
							if (temp.size() > neighbor.threat.size()) {
								neighbor.threat = temp;
							}
						}
					}
				}
			}
			Location answer = locationMap.get(1);
			System.out.println("Case #" + (i + 1) + ": " + (answer.distance - 1) + " " + (answer.threat.size() - answer.distance));
		}
	}
}
