import java.util.*;

public class Problem {
	public static void main(String... args) {
		for (DataSet dataSet : new DataSets())
			handleDataSet(dataSet);
	}


	private static void handleDataSet(DataSet dataSet) {
		System.out.println(
			"Case #" + dataSet.number + ": " + dataSet.getResult());
	}

	public static class DataSet {
		public long number;
		public int firstRow;
		public int[][] firstArrangement;
		public int secondRow;
		public int[][] secondArrangement;

		public String getResult() {
			int firstHit = 0;
			int hits = 0;
			for (int candidate : firstArrangement[firstRow - 1])
				for (int x : secondArrangement[secondRow - 1]) {
					if (candidate == x) {
						firstHit = x;
						++hits;
					}
				}
			if (hits == 0)
				return "Volunteer cheated!";
			else if (hits == 1)
				return Integer.toString(firstHit);
			else
				return "Bad magician!";		
		}
	}

	public static class DataSets implements Iterable<DataSet> {
		public Iterator<DataSet> iterator() {
			return new DataSetsIterator();
		}		
	}

	public static class DataSetsIterator implements Iterator<DataSet> {
		private final long numberOfDataSets;
		private final Scanner sc;
		private long indexOfCurrentDataSet; //zero based

		public DataSetsIterator() {
			sc = new Scanner(System.in);
			numberOfDataSets = sc.nextLong();
			nextLine();
			indexOfCurrentDataSet = 0;
		}

		public boolean hasNext() {
			return indexOfCurrentDataSet < numberOfDataSets;
		}

		public DataSet next() {
			DataSet dataSet = new DataSet();
			dataSet.number = ++indexOfCurrentDataSet;
			dataSet.firstRow = sc.nextInt();
			nextLine();
			dataSet.firstArrangement = readArrangement();
			dataSet.secondRow = sc.nextInt();
			dataSet.secondArrangement = readArrangement();
			return dataSet;
		}

		private int[][] readArrangement() {
			int[][] arrangement = new int[4][4];
			for (int row = 0; row < 4; ++row)
				for (int column = 0; column < 4; ++column)
					arrangement[row][column] = sc.nextInt();
			return arrangement;
		}

		private void nextLine() {
			sc.nextLine();
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
