
package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * Code Jam <br />
 * Qualification Round 2010 <br />
 * Snapper Chain
 * 
 * @author manishmaheshwari
 * @version 1.0 May 8, 2010
 */
public class SnapperChain {

	static Map<Integer, Integer> mask = new HashMap<Integer, Integer>( 31 );
	/**
	 * @param args
	 */
	public static void main ( String[] args ) throws IOException {
		SnapperChain snapper = new SnapperChain();
		FileReader input =
				new FileReader( "/Users/manishmaheshwari/Desktop/A-small.in" );
		FileWriter output =
				new FileWriter( "/Users/manishmaheshwari/Desktop/A-small.out" );
		for ( int i = 0; i <= 30; i++ ) {
			mask.put( i, (int) (Math.pow( 2, i ) - 1) );
		}
		snapper.run( input, output );
		input.close();
		output.close();
	}

	private void run ( FileReader input, FileWriter output ) throws IOException {
		BufferedReader reader = new BufferedReader( input );
		BufferedWriter writer = new BufferedWriter( output );
		String line = reader.readLine();
		int T = Integer.parseInt( line );
		int index = 0;
		while ( index < T && line != null ) {
			line = reader.readLine();
			if ( line != null ) {
				StringTokenizer stok = new StringTokenizer( line );
				int N = Integer.parseInt( stok.nextToken() );
				int K = Integer.parseInt( stok.nextToken() );
				boolean isOn = process( N, K );
				writer.write( "Case #" + (index + 1) + ": " + (isOn ? "ON" : "OFF")
						+ "\n" );
				index++;
			}
		}
		if ( index != T ) {
			throw new IOException( "Error reading file." );
		}
		writer.flush();
	}

	private boolean process ( int n, int k ) {
		int stateAfterSnaps = k & mask.get( n );
		return (stateAfterSnaps == mask.get( n ));
	}

}
