import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class TicTac {

	private static String[] result = new String[] { "X won", "O won", "Draw",
			"Game has not completed" };

	/**
	 * @param args
	 */
	public static void main(String[] args) throws NumberFormatException,
			IOException {
		// System.setIn(new FileInputStream("/Users/dumanshu/Desktop/tictac"));
		BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));
		String str = bf.readLine();

		int T = Integer.parseInt(str);
		char[][] mat = new char[4][4];
		String[] output = new String[T];
		for (int i = 1; i <= T; i++) {
			for (int j = 0; j < 4; j++) {
				String s = bf.readLine();
				mat[j] = s.toCharArray();
			}
			int k = solve(mat);
			output[i - 1] = "Case #" + i + ": " + result[k];
			bf.readLine();
		}
		for (int i = 0; i < T; i++) {
			System.out.println(output[i]);
		}
	}

	private static int solve(char[][] mat) {
		int ti = -1;
		int tj = -1;
		boolean dot = false;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (mat[i][j] == 'T') {
					ti = i;
					tj = j;
				} else if (mat[i][j] == '.') {
					dot = true;
				}
			}
		}
		if (validate(mat, ti, tj, 'X')) {
			return 0;
		}

		if (validate(mat, ti, tj, 'O')) {
			return 1;
		}

		if (dot)
			return 3;
		return 2;
	}

	private static boolean validate(char[][] mat, int ti, int tj, char c) {
		setT(mat, ti, tj, c);
		if (checkRowCol(mat, c, false) || checkRowCol(mat, c, true)
				|| checkDiagonal(mat, c, false) || checkDiagonal(mat, c, true)) {
			return true;
		}
		return false;
	}

	private static void setT(char[][] mat, int ti, int tj, char c) {
		if (ti != -1) {
			mat[ti][tj] = c;
		}
	}

	private static boolean checkDiagonal(char[][] mat, char c, boolean swap) {
		for (int j = 0; j < 4; j++) {
			// check diagonal
			if (swap) {
				if (mat[j][3 - j] != c) {
					return false;
				}
			} else {
				if (mat[j][j] != c) {
					return false;
				}
			}
		}
		return true;

	}

	private static boolean checkRowCol(char[][] mat, char c, boolean swap) {
		for (int i = 0; i < 4; i++) {
			boolean val = true;
			for (int j = 0; j < 4; j++) {
				if (swap) {
					if (mat[i][j] != c) {
						val = false;
					}
				} else {
					if (mat[j][i] != c) {
						val = false;
					}
				}
			}
			if (val)
				return true;
		}
		return false;
	}
}