/**
 * @author Maxim Degtyarev <mdegtyarev@gmail.com>
 */
import java.io.*;
import java.util.*;

public class ProblemA {

    private final Scanner input;
    private final PrintStream output;


    private String solveCase() {
    	final long initialRadius = input.nextLong();
		long paintVolume = input.nextLong();
		int result = 0;

		long innerRadius = initialRadius;
		long outerRadius = innerRadius + 1;
		long delta = ((outerRadius * outerRadius) - (innerRadius * innerRadius));

		do {
			paintVolume -= delta;
			delta += 4;
			if (paintVolume >= 0) result++;
		} while (paintVolume > 0);

		return Integer.toString(result);
    }

    private void invoke() {
        int caseCount = input.nextInt();

        String rest = input.nextLine();

        assert rest.length() == 0 : rest;

        String result;
        for(int caseNumber = 1; caseNumber <= caseCount; caseNumber++) {
            result = solveCase();
            output.printf("Case #%d: %s\n", caseNumber, result);
        }        
    }
    
    private ProblemA(InputStream input, PrintStream output) {
        this.input = new Scanner(input);
        this.output = output;
    }     
    
    public static void main(String... args) throws FileNotFoundException {

        InputStream inputStream;
        PrintStream outputStream;
        
        if (args.length > 0) {
            
            final String inputFileName = args[0];
            final String outputFileName;
            
            if (inputFileName.endsWith(".in")) {
                outputFileName = inputFileName.substring(0, inputFileName.length() - 3) + ".out";
            } else {
                outputFileName = inputFileName + ".out";
            }

            inputStream = new FileInputStream(inputFileName);
            outputStream = new PrintStream(outputFileName);

        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        
        ProblemA instance = new ProblemA(inputStream, outputStream);
        
        instance.invoke();        
    }

}
