package gordosort;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.Hashtable;
import java.util.Locale;

public class GordoSortTask {
	private ArrayList<Integer> values = new ArrayList<Integer>();
	private ArrayList<Integer> sortedValues = new ArrayList<Integer>();	
	private ArrayList<Boolean> hold = new ArrayList<Boolean>();
	private int numAverage = 0;
	private int correctPosAtStart = 0;
	
	public GordoSortTask(){

	}
	
	public void addValue(int value) {
		// TODO Auto-generated method stub
		this.values.add(value);
		System.out.println(value);
	}
	
	private void initArray(){
		sortedValues.addAll(values);
		Collections.sort(sortedValues);
		for(int i=0;i<values.size();i++){
			if(i+1==values.get(i)){
				hold.add(true);//Value in right place
				correctPosAtStart++;
			}else{
				hold.add(false);
			}
		}
	}

	private int findComplement(){
		for(int i=0;i<values.size();i++){
			int value = values.get(i);
			if(value<=values.size()&&!hold.get(i)){
				if((i+1)==values.get(value-1)){
					return i+1;
				}
			}
		}
		return 0;
	}
	
	private int findSingleton(){
		for(int i=0;i<values.size();i++){
			if(!hold.get(i)){
				return i+1;
			}
		}
		return 0;
	}
	
	public String solveTask(){
		String result = "";
		initArray();
		boolean sorted = false;
		int numsToSort = values.size()-this.correctPosAtStart;
		while(!sorted){
			int complement = findComplement();
			if(complement!=0){
				numAverage +=2;
				hold.set(complement-1, true);
				hold.set(values.get(complement-1)-1, true);
				
				int value1 = values.get(complement-1);
				int value2 = values.get(values.get(complement-1)-1);
				int index = values.get(complement-1)-1;
				values.set(complement-1, value2);
				values.set(index, value1);				
			}else{
				int singleton = findSingleton();
				if(singleton!=0){
					numAverage +=2;
					//Update array
					int value1 = values.get(singleton-1);
					int index = value1-1;
					int value2 = values.get(index);
					hold.set(index, true);					
					values.set(singleton-1, value2);
					values.set(index, value1);				
				}
			}
			if(!hold.contains(false)){
				sorted = true;				
			}
		}
		NumberFormat myFormatter = NumberFormat.getInstance(Locale.US);
		myFormatter.setMinimumFractionDigits(6);
		//new DecimalFormat("######.000000");
		result += myFormatter.format((double)numAverage);
		//result += (double)numAverage;
		System.out.println(result);
		return result;
	}
}
