import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class AssignmentB2013
{
	//private static String filename = "test";
	//private static String filename = "B-small-attempt0";
	private static String filename = "B-small-attempt0";
	//private static String filename = "B-large";

	private static boolean debug = false;

	private static int caseindex = 1;

	public static void main(String[] args) throws Exception
	{
		if (debug)
			System.out.println("Start out buffer");

		BufferedWriter out = new BufferedWriter(new FileWriter(filename + ".out"));
		BufferedReader in = new BufferedReader(new FileReader(filename + ".in"));

		performAtStart();

		readFile(in, out);

		out.close();
		in.close();
		System.out.println("Complete!");
	}

	public static void writeToFile(BufferedWriter out, String s)
	{
		try
		{
			if (debug == true)
			{
				String write = "Case #" + caseindex + ": " + s;
				System.out.println("write: " + write);
				out.write(write);
			}
			else
				out.write("Case #" + caseindex + ": " + s);
			out.newLine();
			caseindex++;
		}
		catch (Exception e)
		{
		}
	}

	public static void readFile(BufferedReader in, BufferedWriter out)
	{
		try
		{
			String str;
			//skip first
			in.readLine();
			while ((str = in.readLine()) != null)
			{
				if (debug == true)
					System.out.println("read: " + str);
				performAction(str.split(" "), out);
			}
		}
		catch (IOException e)
		{
		}
	}

	public static void performAtStart()
	{

	}

	static int[][] col;
	static int[] highestrow;
	static int[] highestcol;
	static int m = 0;
	static int n = 0;
	static int ncurr = 0;

	static void reset(int in, int im)
	{
		n = in;
		m = im;
		col = new int[n][m];
		highestrow = new int[n];
		highestcol = new int[m];
		ncurr = 0;
	}

	public static void performAction(String[] row, BufferedWriter out)
	{
		if (n == 0)
		{
			int in = Integer.parseInt(row[0]);
			int im = Integer.parseInt(row[1]);
			reset(in, im);
			return;
		}

		//set highest row and col value and make a grid
		int val;
		for (int i = 0; i < m; i++)
		{
			val = Integer.parseInt(row[i]);
			col[ncurr][i] = val;

			if (highestrow[ncurr] < val)
				highestrow[ncurr] = val;
			if (highestcol[i] < val)
				highestcol[i] = val;
		}
		ncurr++;
		if (ncurr >= n)
		{
			//check fields
			for (int x = 0; x < m; x++)
			{
				for (int y = 0; y < n; y++)
				{
					if (col[y][x] != highestrow[y] && col[y][x] != highestcol[x])
					{
						//write NO
						writeToFile(out, "NO");
						n = 0;
						return;
					}
				}
			}
			//write yes
			writeToFile(out, "YES");
			n = 0;
		}
	}
}
