package painting;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Painting
{

	static final int WHITE = 0;
	static final int BLUE = 1;
	static final int RED = 2;
	static final int RED_CHILD = 3;
	
	public static void main(String[] args) throws NumberFormatException, IOException
	{
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int problems = Integer.parseInt(br.readLine());
		
		for(int i = 0;i < problems;i++)
		{
			int width = 0, height = 0;
			{
				String[] dim = br.readLine().split(" ");
				
				height = Integer.parseInt(dim[0]);
				width = Integer.parseInt(dim[1]);
			}
			
			int[][] painting = new int[width][height];
			
			for(int j = 0;j < height;j++)
			{
				char[] row = br.readLine().toCharArray();
				
				for(int k = 0;k < width;k++)
				{
					switch(row[k])
					{
					case '.':
						painting[k][j] = WHITE;
						break;
					case '#':
						painting[k][j] = BLUE;
						break;
					}
				}
			}
			
			boolean possible = true;
			{
				int[] colCount = new int[width];
				for(int row = 0;row < height && possible;row++)
				{
					int rowCount = 0;
					for(int col = 0;col < width && possible;col++)
					{
						
						if(painting[col][row] == BLUE)
						{
							rowCount++;
							colCount[col]++;
						}
	
						if(painting[col][row] == WHITE)
						{
							if(((rowCount | colCount[col]) & 1) > 0)
								possible = false;
							rowCount = 0;
							colCount[col] = 0;
						}
					}
					if((rowCount & 1) > 0)
					{
						possible = false;
					}
				}
				
				for(int c : colCount)
					if((c & 1) > 0)
						possible = false;
			}
			
			System.out.println("Case #" + (i + 1) + ":");
			
			if(possible)
			{
				char[][] output = new char[width][height];
				for(int y = 0;y < height;y++)
				{
					for(int x = 0;x < width;x++)
					{
						if(painting[x][y] == WHITE)
						{
							output[x][y] = '.';
						}
						else if(painting[x][y] == BLUE)
						{
							painting[x][y] = RED;
							painting[x+1][y] = RED_CHILD;
							painting[x][y+1] = RED_CHILD;
							painting[x+1][y+1] = RED_CHILD;
							
							output[x][y] = output[x+1][y+1] = '/';
							output[x+1][y] = output[x][y+1] = '\\';
						}
						System.out.print(output[x][y]);
					}
					System.out.println();
				}
			}
			else
			{
				System.out.println("Impossible");
			}
		}
	}
	
}
