import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class ThemePark {
	private String processInput(String input, String inputLine2) {
		StringTokenizer st = new StringTokenizer(input, " ");
		int r = Integer.parseInt(st.nextToken());
		int k = Integer.parseInt(st.nextToken());
		int n = Integer.parseInt(st.nextToken());
		
		st = new StringTokenizer(inputLine2, " ");
		Queue <Integer> riders = new LinkedList <Integer>();
		
		for (int i = 0; i < n; i++) {
			riders.add(Integer.parseInt(st.nextToken()));
		}
	
		return totalProfit(riders, n, r, k) + "";
	}
	
	private int totalProfit(Queue <Integer> riders, int n, int r, int k) {
		int totalProfit = 0;
		int numRiding = 0;
		int nextGroup;
		for (int i = 0; i < r; i++) {
//			System.out.println("Iteration " + i);
//			System.out.println("Queue: " + riders);
			for (int j = 0; j < n && numRiding < k; j++) {
				nextGroup = riders.peek();
				if (numRiding + nextGroup > k) {
					break;
				}
//				System.out.print(nextGroup + " ");
				numRiding += riders.poll();
				riders.add(nextGroup);
			}
			totalProfit += numRiding;
			numRiding = 0;
//			System.out.println();
		}
		
		return totalProfit;
	}
	
	private void readFile(String fileName) {
		try {
			FileWriter temp = new FileWriter(new File("output0.txt"));
			BufferedReader fileIn = new BufferedReader(new FileReader(fileName));

			String line = fileIn.readLine();
			String line2;
			int caseNumber = 0;
			while ((line = fileIn.readLine()) != null) {
				line2 = fileIn.readLine();
				temp.write("Case #" + ++caseNumber + ": " + processInput(line, line2) + "\n");
			}
			temp.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		ThemePark themePark = new ThemePark();
		themePark.readFile("file.in");
	}
}
