import java.util.*;

public class Problem {
	public static void main(String... args) {
		Locale.setDefault(Locale.ENGLISH);
		for (DataSet dataSet : new DataSets())
			handleDataSet(dataSet);
	}


	private static void handleDataSet(DataSet dataSet) {
		System.out.println(
			"Case #" + dataSet.number + ":\n" + dataSet.getResult());
	}

	public static class DataSet {
		public long number;
		public int rows, columns, mines;

		public String getResult() {
			try {
				return getResult(rows, columns, mines);
			} catch (RuntimeException e) {
				return "Impossible";
			}
		}

		String getResult(int r, int c, int m) {
			if (r == 1)
				return getSingleRowResult(c, m);
			else if (c == 1)
				return getSingleColumnResult(r, m);
			else if (r == 2)
				return getTwoRowsResult(c, m);
			else if (c == 2)
				return getTwoColumnsResult(r, m);
			else if (m >= c)
				return mines(c) + "\n" + getResult(r - 1, c, m - c);
			else if (m == c - 1)
				return mines(c - 2) + empty(2) + "\n" + mines(1) + empty(c - 1) + "\n" + getResult(r - 2, c, 0);
			else
				return mines(m) + empty(c - m) + "\n" + getResult(r - 1, c, 0);
		}

		String getSingleRowResult(int c, int m) {
			if (m > c - 2)
				throw new RuntimeException();
			else
				return "c" + empty(c -m -1) + mines(m);
		}

		String getSingleColumnResult(int r, int m) {
			if (m > r - 2)
				throw new RuntimeException();
			else
				return "c" + repeat("\n.", r -m -1) + repeat("\n*", m);
		}

		String getTwoRowsResult(int c, int m) {
			if (m % 2 == 1)
				throw new RuntimeException();
			else
				return empty(c - (m / 2)) + mines(m / 2) + "\n" + getSingleRowResult(c, m / 2); 
		}

		String getTwoColumnsResult(int r, int m) {
			if (m % 2 == 1)
				throw new RuntimeException();
			else if (m == 0)
				return empty(2) + "\n" + getResult(r - 1, 2, 0);
			else
				return mines(2) + "\n" + getResult(r - 1, 2, m - 2); 
		}

		String empty(int count) {
			return repeat(".", count);
		}

		String mines(int count) {
			return repeat("*", count);
		}

		String repeat(String c, int count) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < count; ++i)
				sb.append(c);
			return sb.toString();
		}
	}

	public static class DataSets implements Iterable<DataSet> {
		public Iterator<DataSet> iterator() {
			return new DataSetsIterator();
		}		
	}

	public static class DataSetsIterator implements Iterator<DataSet> {
		private final long numberOfDataSets;
		private final Scanner sc;
		private long indexOfCurrentDataSet; //zero based

		public DataSetsIterator() {
			sc = new Scanner(System.in);
			numberOfDataSets = sc.nextLong();
			nextLine();
			indexOfCurrentDataSet = 0;
		}

		public boolean hasNext() {
			return indexOfCurrentDataSet < numberOfDataSets;
		}

		public DataSet next() {
			DataSet dataSet = new DataSet();
			dataSet.number = ++indexOfCurrentDataSet;
			dataSet.rows = sc.nextInt();
			dataSet.columns = sc.nextInt();
			dataSet.mines = sc.nextInt();
			nextLine();
			return dataSet;
		}

		private void nextLine() {
			sc.nextLine();
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
