import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


public class Mote {
    
    private static String inputFile = "/Users/Abhishek/input1.txt";
    private static String outputFile = "/Users/Abhishek/output1.txt";
    public static void main(String[] arg) throws Exception
    {
        BufferedReader reader = new BufferedReader(new FileReader(new File(inputFile)));
        BufferedWriter writer = new BufferedWriter(new FileWriter(new File(outputFile)));
        int testCaseCount = Integer.parseInt(reader.readLine());
        
        for(int testCase=1;testCase<=testCaseCount;testCase++)
        {
            String entries[] = reader.readLine().split(" ");
            long myMoteSize = Long.parseLong(entries[0]);
            int numOfMotes = Integer.parseInt(entries[1]);
            
            String moteSizes[] = reader.readLine().split(" ");
            List<Long> moteSizeList = new ArrayList<Long>();
            
            for(int i=0;i<numOfMotes;++i)
            {
                moteSizeList.add(Long.parseLong(moteSizes[i]));
            }
            
            Collections.sort(moteSizeList);
            int count = findOperationCount(myMoteSize,moteSizeList,0);
            writer.write("Case #"+testCase+": "+count+"\n");
            System.out.println("Case #"+testCase+": "+count+"\n");
        }
        
        writer.close();
        reader.close();
    }
    
    static int findOperationCount(long currentSize,List<Long> moteSizeList, int pos)
    {
        if(pos>=moteSizeList.size())
            return 0;
        
        long newSize = moteSizeList.get(pos);
        if(currentSize>newSize)
            return findOperationCount(currentSize+newSize, moteSizeList, pos+1);
     
        if(currentSize-1==0)
            return 1+findOperationCount(currentSize, moteSizeList, pos+1);
        
        return 1+Math.min(findOperationCount(currentSize, moteSizeList, pos+1),
                findOperationCount(currentSize+currentSize-1, moteSizeList, pos));
    }

}
