import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Locale;
import java.util.Scanner;
import java.util.StringTokenizer;

public class Solver {
	static Scanner in;
	static PrintStream out;

	static void solve(int caseNb) {
		String frac = in.nextLine();
		StringTokenizer tok = new StringTokenizer(frac, "/");
		long P = Integer.parseInt(tok.nextToken());
		long Q = Integer.parseInt(tok.nextToken());
		long div = pgcd(Q, P);
		P /= div;
		Q /= div;

		if (Q % 2 == 1) {
			out.println("Case #" + (caseNb + 1) + ": impossible");
		} else {
			int result = 0;
			if (P < Q) {
				while (P < Q) {
					result++;
					P *= 2;
				}

			}
			out.println("Case #" + (caseNb + 1) + ": " + result);
		}
	}

	static long pgcd(long a, long b) {
		if (a < b) // on veut le premier argument plus grand
			return (pgcd(b, a));
		else if (b == 0)
			return (a);
		else {
			return (pgcd(b, a % b));
		}
	}

	public static void main(String[] args) throws FileNotFoundException {
		Locale.setDefault(new Locale("en", "US"));
		in = new Scanner(new FileInputStream("inputs/A-small-attempt0.in"));
		 out = new PrintStream("outputs/A-small-attempt0.out");

		// in = new Scanner(System.in);
//		out = System.out;

		int cases = in.nextInt();
		in.nextLine();
		for (int i = 0; i < cases; i++)
			solve(i);
	}

}