//package DeceitfulWar;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;

public class DeceitfulWar {
 private BufferedReader in;
 private PrintWriter out;

 final String file = "D-small-attempt0";

 public void run() throws IOException {
  in = new BufferedReader(new FileReader(file + ".in"));
  out = new PrintWriter(file + ".out");

  int iNumberofTests = Integer.parseInt(in.readLine());

  for (int i = 0; i < iNumberofTests; i++) {
   int N = Integer.parseInt(in.readLine());
   String[] SNaomiWts = in.readLine().split("\\s+");
   String[] SKenWts = in.readLine().split("\\s+");

   double[] NaomiWts = new double[N];
   double[] KenWts = new double[N];

   for (int j = 0; j < N; j++) {
    NaomiWts[j] = Double.parseDouble(SNaomiWts[j]);
    KenWts[j] = Double.parseDouble(SKenWts[j]);
   }

   Arrays.sort(NaomiWts);
   Arrays.sort(KenWts);

   out.printf("Case #%d: ", i + 1);
   out.printf(solveDWar(NaomiWts, KenWts, N) + " ");
   out.printf(solveWar(NaomiWts, KenWts, N) + "");
   out.println();
  }
  in.close();
  out.close();
 }

 private int solveDWar(double[] naomiWts, double[] kenWts, int N) {
  int wins = 0;
  int n = 0, k = 0;
  while (n < N) {
   if (naomiWts[n] > kenWts[k]) {
    n++;
    k++;
    wins++;
   } else {
    n++;
   }
  }
  return wins;
 }

 private int solveWar(double[] naomiWts, double[] kenWts, int N) {
  int loss = 0;
  int n = 0, k = 0;
  while (k < N) {
   if (naomiWts[n] < kenWts[k]) {
    n++;
    k++;
    loss++;
   } else {
    k++;
    // wins++;
   }
  }
  return N - loss;
 }

 public static void main(String[] args) throws IOException {
  Locale.setDefault(Locale.US);
  new DeceitfulWar().run();
 }

}