import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

/**
 * Qualification Round 2013 : Problem C. Fair and Square
 */
public class C {
	
	private int A,B;
	
	private void goodluck() throws Exception {
		// ready variables
		int numberOfCases;
		
		// get file
		Scanner sc = new Scanner(new File("/Users/teuskim/codejam/C-small-attempt0.in.txt"));
		numberOfCases = sc.nextInt();
		
		// make output
		File file = new File("/Users/teuskim/codejam/C-small-attempt0.out.txt");
		if(file.exists() == false)
			file.createNewFile();
		FileWriter fw = new FileWriter(file);
		for(int casenum=0; casenum<numberOfCases; casenum++){
			
			A = sc.nextInt();
			B = sc.nextInt();
			
			String result = ""+getResult();
			fw.write("Case #"+(casenum+1)+": "+result+"\n");
			print("Case #"+(casenum+1)+": "+result);
		}
		fw.close();
	}
	
	private static final double EPS = 1e-7;
	private int getResult(){
		int result = 0;
		for(int i=A; i<=B; i++){
			if(isPalindrome(i)){
				double sqrt = Math.sqrt(i);
				if(sqrt < Math.floor(sqrt)+EPS){
					if(isPalindrome((int)sqrt)) result++;
				}
			}
		}
		return result;
	}
	
	private boolean isPalindrome(int num){
		String str = ""+num;
		int end = str.length()/2 + 1;
		for(int i=0; i<end; i++){
			if(str.charAt(i) != str.charAt(str.length()-i-1)){
				return false;
			}
		}
		return true;
	}
	
	public static void main(String[] args){
		print("start!");
		try{
			
			new C().goodluck();
			
		}catch(Exception e){
			e.printStackTrace();
		}
		print("end!");
	}
	
	
	/**********************
	 * code for debugging *
	 **********************/
	
	public void check(boolean isRight, String log){
		if(isRight == false){
			print("exit: "+log);
			System.exit(0);
		}
	}
	
	public static void print(String str){
		System.out.println(str);
	}
	
	public static void print(int[] arr){
		if(arr == null) print("null");
		else{
			String str = "[";
			if(arr.length > 0){
				for(int i=0; i<arr.length; i++) str += arr[i]+",";
				str = str.substring(0, str.length()-1);
			}
			str += "]";
			print(str);
		}
	}
}
