import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class Lawnmower {
	private static final String PATH = "src\\ressources";
	private static final String PROBLEM = "B";
	private static final String VERSION = "small-attempt1"; //large
	private static final String EXT_IN = "in";
	private static final String EXT_OUT = "out";
	
	private int[][] grid;
	private int row;
	private int col;
	
	public String solve(Scanner in) {
		row = in.nextInt();
		col = in.nextInt();
		grid = new int[row][col];
		for(int i = 0; i < row; i++) {
			for(int j = 0; j < col; j++) {
				grid[i][j] = in.nextInt();
			}
		}
		for(int i = 0; i < row; i++) {
			for(int j = 0; j < col; j++) {
				if(grid[i][j] == 1 && !check(i, j)) {
					return "NO";
				}
			}
		}
		return "YES";
	}
	
	private boolean check(int i, int j) {
		boolean okH = true;
		for(int k = 0; k < row; k++) {
			if(grid[k][j] == 2) {
				okH = false;
			}
		}
		boolean okV = true;
		for(int k = 0; k < col; k++) {
			if(grid[i][k] == 2) {
				okV = false;
			}
		}
		return okH || okV;
	}
	
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(getCompletPath(EXT_IN)));
		PrintWriter out = new PrintWriter(new FileWriter(getCompletPath(EXT_OUT)));
		
		int nbTestCase = in.nextInt();
		Lawnmower pb = new Lawnmower();
		for(int i = 0; i < nbTestCase; i++) {
			out.println("Case #" + (i+1) + ": " + pb.solve(in));
			out.flush();
		}
		
		in.close();
		out.close();
	}
	
	private static String getCompletPath(String ext) {
		return PATH + "\\" + PROBLEM + "-" + VERSION + "." + ext;
	}
}
