package candysplit;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.Iterator;


public class CandySplit {
	private String outFile = null;
	private ArrayList<CandySplitTask> tasks = new ArrayList<CandySplitTask>();	
	
	public CandySplit(String outFile){
		this.outFile = outFile;
	}
		
	public boolean readInputFile(String file){
		int numEntries = 0;
		BufferedReader br =null;
		String line = "";
		try {
			br = new BufferedReader(new FileReader(new File(file)));
			numEntries = new Integer(br.readLine());
			//System.out.println(numEntries);
			String candyTaskString = "";
			for(int i=0;i<numEntries;i++){
				CandySplitTask cst = new CandySplitTask();
				int numValues = new Integer(br.readLine());
				cst.initMatrix(numValues);
				//System.out.println(numValues);
				candyTaskString = br.readLine();
				StringTokenizer tokenizer = new StringTokenizer(candyTaskString);
				for(int j=0;j<numValues;j++){
					System.out.println(j);
					cst.addValue(new Long(tokenizer.nextToken()));
				}
				this.tasks.add(cst);
			}
			br.close();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
			return false;
		}
		return true;
	}
	
	public void solveTasks(){
		Iterator<CandySplitTask> iter = this.tasks.iterator();
		String result = "";		
		int count = 1;
		int cnt2 = 1;
		while(iter.hasNext()){
			//System.out.println("RESULT:");			
			result += "Case #" + count++ + ": ";
			result += iter.next().solveTask() + "\n";
			/*if(cnt2++==100){
				System.out.println(count);
				cnt2 = 1;
			}*/
			///System.out.println(result);
		}
		saveResult(result);
		System.out.println("RESULT:");
		System.out.println(result);		
	}
		
	private void saveResult(String result){
		
		try {
			FileWriter fw = new FileWriter(outFile);
			BufferedWriter out = new BufferedWriter(fw);
		    out.write(result);
		    out.close();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
		}
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		CandySplit candysplit = new CandySplit(args[1]);
		candysplit.readInputFile(args[0]);
		candysplit.solveTasks();
		System.exit(0);
	}


}
