import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;


public class Magicka {

	public static void main(String[] args)
	{
		ArrayList<Character> base = new ArrayList<Character>();
		base.add('Q');
		base.add('W');
		base.add('E');
		base.add('R');
		base.add('A');
		base.add('S');
		base.add('D');
		base.add('F');
		
		Scanner scan = new Scanner(System.in);
		
		int numCases = Integer.parseInt(scan.next());
		
		for(int c = 0; c < numCases; c++)
		{
			// PREPARE 2D ARRAYS
			
			boolean[][] opposed = new boolean[8][8];
			char[][] combos = new char[8][8];
			
			for(int i = 0; i < opposed.length; i++)
			{
				Arrays.fill(opposed[i], false);
				Arrays.fill(combos[i], '*');		// '*' means no combo
			}
			
			// END PREPARATION
			
			int numCombos = Integer.parseInt(scan.next());
			
			for(int i = 0; i < numCombos; i++)
			{
				String comboString = scan.next();
				
				char ingredient1 = comboString.charAt(0);
				char ingredient2 = comboString.charAt(1);
				char result = comboString.charAt(2);
				
				int index1 = base.indexOf(ingredient1);
				int index2 = base.indexOf(ingredient2);
				
				combos[index1][index2]	= result;
				combos[index2][index1] = result;
			}
			
			int numOpposed = Integer.parseInt(scan.next());
			
			for(int i = 0; i < numOpposed; i++)
			{
				String opposedString = scan.next();
				
				char enemy1 = opposedString.charAt(0);
				char enemy2 = opposedString.charAt(1);
				
				int index1 = base.indexOf(enemy1);
				int index2 = base.indexOf(enemy2);
				
				opposed[index1][index2] = true;
				opposed[index2][index1] = true;
			}
			
			// MAKE OUTPUT
			
			int inputLength = Integer.parseInt(scan.next());
			
			String input = scan.next();
			
			String output = "";
			
			
			while(input.length() > 0)
			{
				char nextChar = input.charAt(0);
				int nextIndex = base.indexOf(nextChar);
				
				// check for combo / opposed
				
				boolean isOpposed = false;
				boolean isCombo = false;
				
				if(output.length() >= 1) // if previous characters exist
				{
					char prevChar = output.charAt(output.length()-1);
					int prevIndex = base.indexOf(prevChar);
					
					//check for combo
					if(prevIndex > -1)	// if prevChar is a base char
					{
						if(combos[nextIndex][prevIndex] != '*')	// if they combine
						{
							output = output.substring(0, output.length()-1) + combos[nextIndex][prevIndex];
							isCombo = true;
						}
					}
					
					//check for opposed
					if(!isCombo)
					{
						for(int i = 0; i < opposed.length; i++)
						{
							if(opposed[nextIndex][i] == true)	// if nextChar has an enemy
							{
								if(output.contains(""+base.get(i).charValue()))	// if nextChar's enemy is in the output
								{
									output = "";
									isOpposed = true;
								}
							}
						}
					}
				}
				
				if(!isOpposed && !isCombo)
				{
					output = output+nextChar;
				}
				
				input = input.substring(1);
			}
			
			// PRINT
			
			System.out.print("Case #"+(c+1)+": [");
			
			for(int i = 0; i < output.length(); i++)
			{
				System.out.print(output.charAt(i));
				
				if(i < output.length()-1)
				{
					System.out.print(", ");
				}
			}
			
			System.out.println("]");
		}
	}
	
}
