package magicka;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Stack;
import java.util.Hashtable;
import java.util.HashSet;
import java.util.Stack;

public class Magicka
{
	
	public static void main(String[] args) throws IOException
	{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int count = Integer.parseInt(br.readLine());
		
		String[] results = new String[count];
		
		for(int k = 0;k < count;k++)
		{
			Hashtable<Integer, Character> combines = new Hashtable<Integer, Character>();
			HashSet<Integer> opposes = new HashSet<Integer>();
			char[] casts = null;
			Stack<Character> stack = new Stack<Character>();
			
			{
				String[] info = br.readLine().split(" ");
				int i = 0;
				
				int combineCount = Integer.parseInt(info[i++]);
				for(int j = 0;j < combineCount;j++)
				{
					String combine = info[i++];
					combines.put(createKey(combine.charAt(0), combine.charAt(1)), combine.charAt(2));
				}
				int opposedCount = Integer.parseInt(info[i++]);
				for(int j = 0;j < opposedCount;j++)
				{
					String oppose = info[i++];
					opposes.add(createKey(oppose.charAt(0), oppose.charAt(1)));
				}
				casts = info[++i].toCharArray();
			}
			
			for(Character c : casts)
			{
				stack.push(c);
				combine(combines, stack);
				oppose(opposes, stack);
			}
			
			String result = "[";
			for(int i = 0;i < stack.size();i++)
			{
				result += stack.get(i);
				if(i < stack.size() - 1)
					result += ", ";
			}
			result += "]";
			results[k] = result;
		}
		
		for(int i = 0;i < results.length;i++)
		{
			System.out.println("Case #" + (i + 1) + ": " + results[i]);
		}
	}
	
	public static int createKey(char e1, char e2)
	{
		if(e1 < e2)
			return (e1 << 8) | e2;
		else
			return (e2 << 8) | e1;
	}
	
	public static void combine(Hashtable<Integer, Character> combines, Stack<Character> v)
	{
		if(v.size() < 2)
			return;
		
		int p = createKey(v.elementAt(v.size() - 1), v.elementAt(v.size() - 2));
		
		if(combines.containsKey(p))
		{
			v.pop();
			v.pop();
			v.push(combines.get(p));
			combine(combines, v);
		}
	}
	
	public static void oppose(HashSet<Integer> opposes, Stack<Character> v)
	{
		if(v.size() < 2)
			return;

		char latest = v.peek();
		
		for(int i = 0;i < v.size() - 1;i++)
		{
			int p = createKey(v.get(i), latest);
			if(opposes.contains(p))
			{
				v.clear();
				return;
			}
		}
	}
	
}
