package de.stefanBirkner;

import static java.lang.Integer.parseInt;
import static org.apache.commons.io.IOUtils.readLines;

import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;

public class DataSetParser {
	public static Boolean[][][] readDataSetFromResource(String name)
	throws IOException {
		Iterator<String> lines = readLinesFromResource(name);
		return readRawDataSetsForTest(lines);
	}

	private static Iterator<String> readLinesFromResource(String name)
			throws IOException {
		InputStream is = DataSetParser.class.getResourceAsStream(name);
		return (Iterator<String>) readLines(is).iterator();
	}

	private static int readLineWithSingleInteger(Iterator<String> lines) {
		return parseInt(lines.next());
	}

	private static Boolean[][][] readRawDataSetsForTest(Iterator<String> lines) {
		int numDataSets = readLineWithSingleInteger(lines);
		Boolean[][][] datasets = new Boolean[numDataSets][][];
		for (int i = 0; i < numDataSets; i++) {
			datasets[i] = readRawDataSet(lines);
		}
		return datasets;
	}

	private static Boolean[][] readRawDataSet(Iterator<String> lines) {
		int size = readLineWithSingleInteger(lines);
		Boolean[][] table =  new Boolean[size][];
		
		for (int i = 0; i < size; i++) {
			table[i] = new Boolean[size];
			char[] row = lines.next().toCharArray();
			for (int j = 0; j < size; j++) {
				table[i][j] = (row[j] == '.') ? null : row[j] == '1';
			}
		}
		return table;
	}
}
