import java.util.*;
import java.math.BigInteger;

public class GCJ3 {

	static Scanner sc = new Scanner(System.in);
	public static void main(String[] args) {
		(new GCJ3()).run();
	}

	public void run() {
		int letters = sc.nextInt();
		int words = sc.nextInt();
		int tests = sc.nextInt();
		WordTree wt = new WordTree();
		sc.skip("\n");
		
		for(int i = 0; i < words; ++i) {
			wt.addWord(sc.next(), 0);
		}
		for(int i = 1;i<=tests; ++i) {
			System.out.print("Case #" + i + ": ");
			figureOut(sc.next(), wt, letters);
		}
	}
	private void figureOut(String s, WordTree wt, int letters) {
		Vector<Vector<Character>> pattern = new Vector<Vector<Character>>(letters);
		boolean inBrackets = false;
		int lettersRead = 0;
		for(int i = 0; i < s.length(); ++i) {
			char c=s.charAt(i);
			if(c <= 'z' && c >= 'a') {
				if(inBrackets) {
					pattern.get(lettersRead).add(c);
				} else {
					Vector<Character> vc = new Vector<Character>(1);
					vc.add(c);
					pattern.add(vc);
					++lettersRead;
				}
			} else {
				if(!inBrackets) {
					pattern.add(new Vector<Character>());
				} else {
					++lettersRead;
				}
				inBrackets = !inBrackets;
			}
		}
		System.out.println(wt.test(pattern, 0));
		
	}
}

class WordTree {
	WordTree[] children;
	char c;
	public WordTree() {
		children = new WordTree[26];
	}
	public void addWord(String s, int letterUpTo) {
		if(children[s.charAt(letterUpTo)-'a'] == null)
			children[s.charAt(letterUpTo)-'a'] = new WordTree();
		if(letterUpTo < s.length()-1)
			children[s.charAt(letterUpTo)-'a'].addWord(s, letterUpTo+1);
	}
	public BigInteger test(Vector<Vector<Character>> pattern, int character) {
		if(character == pattern.size()) return BigInteger.ONE;
		BigInteger sum = BigInteger.ZERO;
		for(char c:pattern.get(character)) {
			if(children[c-'a'] != null) {
				sum = sum.add(children[c-'a'].test(pattern, character+1));
			}
		}
		return sum;
	}
}
