package mp.kotter.challenges.gcj.round2;

import java.io.IOException;
import java.util.List;

import mp.kotter.challenges.utils.Solution;

public class ManyPrizes extends Solution {

    public static final long MODULO = 1000002013L;

    public static void main(final String[] args) throws Exception {
        (new ManyPrizes()).run(args);
    }

    @Override
    protected void solve() throws Exception {
        final int T = Integer.parseInt(getInput().readLine());

        for(int c=0; c<T; c++) {
            writeCaseResult(c, solveCase());
        }
    }

    private String solveCase() throws IOException {
        final List<Long> input = readLongs();
        final long n = input.get(0);
        final long p = input.get(1);
        return "" + findLastInPrize(n, p, new WorstPosition()) + " " + findLastInPrize(n, p, new BestPosition());
    }

    private long findLastInPrize(final long n, final long p, final PosFunciton position) {
        long start = 0;
        long end = (1 << n) - 1;

        while (start < end) {
            final long m = (start + end + 1) / 2;
            final long pos = position.position(n, m);
            if (pos < p) {
                start = m;
            } else {
                end = m - 1;
            }
        }

        return start;
    }

    public interface PosFunciton {
        long position(final long n, final long t);
    }

    public class BestPosition implements PosFunciton {

        @Override
        public long position(final long n, final long t) {
            return findPosition(n, t);
        }

        private long findPosition(final long n, final long t) {
            if (t == (1 << n) - 1 || t == 0) {
                return t;
            }

            final long teamsBehind = (1 << n) - t - 2;
            final long newTeamsBehind = teamsBehind / 2;
            final long newPosition = (1 << (n - 1)) - newTeamsBehind - 1;

            return findPosition(n - 1, newPosition);
        }

    }

    public class WorstPosition extends BestPosition {

        @Override
        public long position(final long n, final long t) {
            final long bestPosition = super.position(n, (1 << n) - t - 1);
            return (1 << n) - bestPosition - 1;
        }
    }
}
