import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class B {
	private String process(String initEnergy, String regain, String numAct, String[] vals) {
		int currentEnergy = Integer.valueOf(initEnergy);
		int maxEnergy = currentEnergy;
		int regainEnergy = Integer.valueOf(regain);
		int numActivities = Integer.valueOf(numAct);
		int totalGain = 0;
		
		int maxValue = 0;
		int maxPos = 0;
		for (int i = 0; i < numActivities; i++) {
			int currentValue = Integer.parseInt(vals[i]);
			
			if (currentValue > maxValue) {
				maxValue = currentValue;
				maxPos = i;
			}
		}
		
		for (int i = 0; i < numActivities - 1; i++) {
			int currentValue = Integer.parseInt(vals[i]);
			
			// Don't waste regained energy
			int haveToSpend = 0;
			int wasted = (currentEnergy + regainEnergy) - maxEnergy;
			if (wasted > 0) {
				haveToSpend = wasted;
			}
			
			int spendEnergy = haveToSpend;
			// Spend all energy if most valuable activity
			if (currentValue == maxValue) {
				spendEnergy = currentEnergy;
			}
			totalGain += currentValue * spendEnergy;
			currentEnergy = currentEnergy - spendEnergy + regainEnergy;
			
			if (currentEnergy > maxEnergy) {
				currentEnergy = maxEnergy;
			}
			//System.out.println("spent " + spendEnergy + " (had to spend " + haveToSpend + ") on i " + i + " with val " + currentValue + " totalgain = " + totalGain);
		}
		
		// Spend any leftover energy on the last
		totalGain += Integer.parseInt(vals[vals.length - 1]) * currentEnergy;
		
		//System.out.println("spent " + currentEnergy + " on last with val = " + Integer.parseInt(vals[vals.length - 1]) + " totalgain = " + totalGain);
		
		return Integer.toString(totalGain);
	}

	public static void main(String[] args) {
		B b = new B();

		if (args.length == 1) {
			BufferedReader br = null;
			int numCases = 0;

			try {
				// Create the output file
				File outputFile = new File("output.out");
				if (!outputFile.exists()) {
					outputFile.createNewFile();
				}

				FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
				BufferedWriter bw = new BufferedWriter(fw);

				// Read input
				br = new BufferedReader(new FileReader(args[0]));

				// First line should contain the number of test cases
				String line = br.readLine();
				numCases = Integer.parseInt(line);

				long startTime = System.currentTimeMillis();

				// Following lines should contain test cases
				for (int i = 1; i <= numCases && line != null; i++) {
					line = br.readLine();
					String[] rangeNums = line.split(" ");
					
					String initEnergy = rangeNums[0];
					String regain = rangeNums[1];
					String numAct = rangeNums[2];
					
					line = br.readLine();
					String[] vals = line.split(" ");

					String outputLine = "Case #" + i + ": "
							+ b.process(initEnergy, regain, numAct, vals);
					System.out.println(outputLine);
					bw.write(outputLine + "\n");
				}

				long endTime = System.currentTimeMillis();

				System.out.println("Execution time = " + (endTime - startTime));

				br.close();
				bw.close();
			} catch (IOException e) {
				System.out.println("Input file not found!");
				e.printStackTrace();
			}
		} else {
			System.err.println("Input file required for processing");
		}
	}

}
