//package MinesweeperMaster;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;

public class MinesweeperMaster {
 private BufferedReader in;
 private PrintWriter out;

 final String file = "C-small-attempt1";

 public void run() throws IOException {
  in = new BufferedReader(new FileReader(file + ".in"));
  out = new PrintWriter(file + ".out");

  int iNumberofTests = Integer.parseInt(in.readLine());

  for (int i = 0; i < iNumberofTests; i++) {
   String[] dim = in.readLine().split("\\s+");
   out.printf("Case #%d: ", i + 1);
   out.println();
   solve(Integer.parseInt(dim[0]), Integer.parseInt(dim[1]),
     Integer.parseInt(dim[2]));
  }
  in.close();
  out.close();
 }

 private void solve(int R, int C, int M) {
  if (isImpossible(R, C, M)) {
   out.printf("Impossible");
   out.println();
   return;
  }
  boolean[][] mineLand = new boolean[R][C];
  int mines = 0;
  int Lx = 0, Ly = 0;
  while (Lx <= R - 1 && mines < M) {
   mines += plantMines(mineLand, Lx, Ly,
     Lx - Math.min(C - Ly - 1, Lx),
     Ly + Math.min(C - Ly - 1, Lx), M - mines);
   Lx++;
  }
  Lx--;
  while (++Ly <= C - 1 && mines < M) {
   mines += plantMines(mineLand, R - 1, Ly,
     Lx - Math.min(C - Ly - 1, Lx),
     Ly + Math.min(C - Ly - 1, Lx), M - mines);
  }

  printSol(mineLand, R, C);

 }

 public static void main(String[] args) throws IOException {
  Locale.setDefault(Locale.US);
  new MinesweeperMaster().run();
 }

}
