package qr2014;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class MinesweeperMaster {
	private static final String PATH = "src\\ressources";
	private static final String PROBLEM = "C";
	private static final String VERSION = "small-attempt3";//"small-attempt0"; //large
	private static final String EXT_IN = "in";
	private static final String EXT_OUT = "out";
	
	public String solve(Scanner in) {
		int row = in.nextInt();
		int col = in.nextInt();
		int mines = in.nextInt();
		
		char[][] board = new char[row][col];
		
		int nbDots = (row * col) - mines;
		int rectDots = (int) Math.sqrt(nbDots);
		
		int h, w;
		int[] opti = new int[2];
		if(rectDots * rectDots == nbDots) {
			opti[0] = rectDots;
			opti[1] = rectDots;
		} else if((rectDots + 1) * rectDots >= nbDots) {
			opti[0] = rectDots + 1;
			opti[1] = rectDots;
		} else {
			opti[0] = rectDots + 1;
			opti[1] = rectDots + 1;
		}
		
		if(opti[0] <= row && opti[1] <= col) {
			h = opti[0];
			w = opti[1];
		} else if(opti[1] <= row && opti[0] <= col) {
			h = opti[1];
			w = opti[0];
		} else if(row <= col) {
			h = row;
			w = nbDots / h;
			if(h * w != nbDots) {
				w++;
			}
		} else {
			w = col;
			h = nbDots / w;
			if(h * w != nbDots) {
				h++;
			}
		}
		
		int countDots = 0;
		
		for(int i = 0; i < row; i++) {
			for(int j = 0; j < col; j++) {
				if(countDots < nbDots && i < h && j < w) {
					board[i][j] = '.';
					countDots++;
				} else {
					board[i][j] = '*';
				}
			}
		}
		
		boolean bC = false;
		if(nbDots == 1  || (board[0][0] == '.' 
				&& (col == 1 || board[0][1] == '.')
				&& (row == 1 || board[1][0] == '.')
				&& (row == 1 || col == 1 || board[1][1] == '.'))) {
			board[0][0] = 'c';
			bC = true;
		}
		
		String boardStr =  "\n";
		
		for(int i = 0; i < row; i++) {
			for(int j = 0; j < col; j++) {
				boardStr += board[i][j];
			}
			if(i < row - 1) {
				boardStr += "\n";
			}
		}
		
		if(bC) {
			return String.valueOf(boardStr);
		}
		return "\nImpossible";
	}
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(getCompletPath(EXT_IN)));
		in.useLocale(Locale.US);
		PrintWriter out = new PrintWriter(new FileWriter(getCompletPath(EXT_OUT)));
		
		int nbTestCase = in.nextInt();
		MinesweeperMaster mm = new MinesweeperMaster();
		for(int i = 0; i < nbTestCase; i++) {
			out.println("Case #" + (i+1) + ": " + mm.solve(in));
			out.flush();
		}
		
		in.close();
		out.close();
	}
	
	private static String getCompletPath(String ext) {
		return PATH + "\\" + PROBLEM + "-" + VERSION + "." + ext;
	}
}
