import java.io.*;
import java.util.StringTokenizer;

public class Lawnmower {

  public String check(int[][] lawn) {
    //each row and col only need to be cut once for any valid patterns
    //find the height of the cut for each row and col (i.e. the tallest grass in that row or col)
    //just check that each grid in the desired pattern
    int rows = lawn.length;
    int cols = lawn[0].length;

    //track highest grass in each row and col
    int[] rowmax = new int[rows];
    int[] colmax = new int[cols];

    //find highest grass in each row
    for (int i=0; i<rows; i++) {
      for (int j=0; j<cols; j++) {
        if (lawn[i][j]>rowmax[i]) rowmax[i]=lawn[i][j];
      }
    }

    //find highest grass in each col
    for (int j=0; j<cols; j++) {
      for (int i=0; i<rows; i++) {
        if (lawn[i][j]>colmax[j]) colmax[j]=lawn[i][j];
      }
    }

    //check if grass at (i,j) in the desired pattern is shorter than tallest grass in row i or col j
    for (int i=0; i<rows; i++) {
      for (int j=0; j<cols; j++) {
        if (lawn[i][j]!=Math.min(rowmax[i], colmax[j])) return "NO";
      }
    }

    return "YES";
  }

  public static void main(String[] args) throws IOException {
    BufferedReader in = new BufferedReader(new FileReader("Lawnmower.in"));
    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("Lawnmower.out")));

    int cases = Integer.parseInt(in.readLine());
    for (int i=0; i<cases; i++) {
      StringTokenizer st = new StringTokenizer(in.readLine());
      int rows = Integer.parseInt(st.nextToken());
      int cols = Integer.parseInt(st.nextToken());

      int[][] lawn = new int[rows][cols];
      for (int row=0; row<rows; row++) {
        st = new StringTokenizer(in.readLine());
        for (int col=0; col<cols; col++) {
          lawn[row][col] = Integer.parseInt(st.nextToken());
        }
      }

      String result = new Lawnmower().check(lawn);
      out.println("Case #"+(i+1)+": "+result);
    }
    in.close();
    out.close();
  }
}