/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package theme.park;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Aaron
 */
public class ThemePark {

    RollerCoaster coaster;
    Queue queue;

    class RollerCoaster {

        private int k;
        private int person;

        public RollerCoaster(int k) {
            this.k = k;
            person = 0;
        }

        public boolean permitEntry(int group) {
            if ((group != -1) && ((person + group) <= k)) {
                person += group;
                return true;
            }
            return false;
        }

        public int getCash() {
            return person;
        }

        public void reset() {
            person = 0;
        }
    }

    class Queue {

        private String[] groups;
        private int first;
        private int last;
        private int advance;

        public Queue(String[] groups) {
            this.groups = groups;
            first = 0;
            last = groups.length - 1;
            advance = 0;
        }

        public int getGroup() {
            if (advance < groups.length) {
                return Integer.parseInt(groups[first]);
            }
            return -1;
        }

        public void nextGroup(boolean entry) {
            if (entry == true) {
                first = (first + 1) % groups.length;
                last = (last + 1) % groups.length;
                advance += 1;
            }
        }

        public void reset() {
            advance = 0;
        }
    }

    public ThemePark(int k, String[] groups) {
        coaster = new RollerCoaster(k);
        queue = new Queue(groups);
    }

    public int nextRide() {
        coaster.reset();
        queue.reset();
        boolean entry = true;
        do {
            entry = coaster.permitEntry(queue.getGroup());
            queue.nextGroup(entry);
        } while (entry == true);
        return coaster.getCash();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        try {
            BufferedReader br = new BufferedReader(new FileReader("C-small.in"));
            FileWriter fw = new FileWriter("C-small.out", false);
            int cases_count = Integer.parseInt(br.readLine());
            for (int i = 0; i < cases_count; i++) {
                String[] values = br.readLine().split(" ");
                String[] groups = br.readLine().split(" ");
                ThemePark park = new ThemePark(Integer.parseInt(values[1]), groups);
                int R = Integer.parseInt(values[0]);
                int total_cash = 0;
                for (int j = 0; j < R; j++) {
                    total_cash += park.nextRide();
                }
                fw.write("Case #" + (i + 1) + ": " + total_cash + "\n");
            }
            br.close();
            fw.close();
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
