import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.Locale;
import java.util.TreeMap;
import java.util.TreeSet;

class Interval {
	final long length;
	final long velocity;
	
	Interval(long length, long velocity) {
		this.length = length;
		this.velocity = velocity;
	}
}

public class CodeJam {
	

	public static void main(String[] args) throws IOException {
		
		String inFileName = args[0];
		BufferedReader in = new BufferedReader(new FileReader(inFileName));
		BufferedWriter out = new BufferedWriter(new FileWriter(inFileName + ".out"));
		int testCases = Integer.parseInt(in.readLine());

		for (int caseNo = 1; caseNo <= testCases; ++caseNo) {
			String caseStr[] = in.readLine().split(" ");
			final long X = Long.parseLong(caseStr[0]);
			final long walkSpeed = Long.parseLong(caseStr[1]);
			final long runSpeed = Long.parseLong(caseStr[2]);
			double runTime = Long.parseLong(caseStr[3]);
			final int N = Integer.parseInt(caseStr[4]);
			
			LinkedList<Interval> intervals = new LinkedList<Interval>();
			long prevEnd = 0;
			
			for (int i = 0; i < N; ++i) {
				String walkWay[] = in.readLine().split(" ");
				long b = Long.parseLong(walkWay[0]);
				long e = Long.parseLong(walkWay[1]);
				long w = Long.parseLong(walkWay[2]);
				
				if (prevEnd < b) {
					intervals.add(new Interval(b - prevEnd, 0));
				}
				intervals.add(new Interval(e - b, w));
				prevEnd = e;
			}
			
			if (prevEnd < X) {
				intervals.add(new Interval(X - prevEnd, 0));
			}
			
			Collections.sort(intervals, new Comparator<Interval>() {

				@Override
				public int compare(Interval arg0, Interval arg1) {
					return Long.signum(arg0.velocity - arg1.velocity);
				}
			});
			
			double time = 0;
			
			for (Interval i : intervals) {
				double length = i.length;
				double velocity = i.velocity;
				
				if (runTime > 0) {
					double rt = Math.min(length / (velocity + runSpeed), runTime);
					time += rt;
					runTime -= rt;
					length -= rt * (velocity + runSpeed);
				}
				
				time += length / (velocity + walkSpeed);
			}
			
			StringBuilder result = new StringBuilder();
			result.append(String.format(Locale.US, "%.9f", time));
			
			final String resultStr = "Case #" + caseNo + ": " + result.toString() + "\n";
			out.write(resultStr);
			System.out.print(resultStr);
			out.flush();
		}
	}
}
