package bottrust;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class BotTrust
{

	final static int ORANGE = 0;
	final static int BLUE = 1;
	
	Robot[] m_aRobots = {new Robot(), new Robot()};
	int[] m_aiNext = {-1, -1};
	
	int[] m_aiButtons;
	int[] m_aiBot;
	int m_iCurr = 0;
	
	int m_iTime = 0;
	
	public static void main(String[] args) throws NumberFormatException, IOException
	{
		int[] results;
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		results = new int[Integer.parseInt(br.readLine())];
		
		for(int i = 0;i < results.length;i++)
		{
			String[] info = br.readLine().split(" ");
			
			int size = Integer.parseInt(info[0]);
			
			int[] buttons = new int[size];
			int[] bots = new int[size];
			
			for(int j = 0;j < size;j++)
			{
				switch(info[j * 2 + 1].charAt(0))
				{
				case 'O':
					bots[j] = ORANGE;
					break;
				case 'B':
					bots[j] = BLUE;
					break;
				}
				
				buttons[j] = Integer.parseInt(info[j * 2 + 2]);
				
				BotTrust b = new BotTrust(buttons, bots);
				results[i] = b.findFastest();
			}
		}
		for(int i = 0;i < results.length;i++)
		{
			System.out.println("Case #" + (i + 1) + ": " + results[i]);
		}
	}
	
	public BotTrust(int[] buttons, int[] bot)
	{
		m_aiButtons = buttons;
		m_aiBot = bot;
		
		for(int i = 0;i < 2;i++)
			m_aiNext[i] = getNext(i);
	}
	
	public int findFastest()
	{
		while(m_iCurr < m_aiButtons.length)
			tick();
		return m_iTime;
	}
	
	public int getNext(int bot)
	{
		for(int i = m_iCurr;i < m_aiBot.length;i++)
		{
			if(m_aiBot[i] == bot)
				return m_aiButtons[i];
		}
		
		return -1;
	}
	
	public void tick()
	{
		int nextToPress = (m_aiBot[m_iCurr]);
		int nextToMove = ((m_aiBot[m_iCurr] + 1) % 2);
		m_aRobots[nextToMove].moveTo(m_aiNext[nextToMove]);
		if(m_aRobots[nextToPress].press(m_aiNext[nextToPress]))
		{
			m_iCurr++;
			m_aiNext[nextToPress] = getNext(nextToPress);
		}
		
		m_iTime++;
	}
	
}
