import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;


public class FairWarning {

	public static void main(String[] args) throws IOException {
		File input = new File("B-small.in");
		BufferedReader reader = new BufferedReader(new FileReader(input));
		
		FileWriter outputStream = new FileWriter("B-out.txt");
		BufferedWriter output = new BufferedWriter(outputStream);

		int C = Integer.parseInt(reader.readLine());
		
		for(int i = 0; i < C; i++)
		{
			String[] line = reader.readLine().split(" ");
			int N = Integer.parseInt(line[0]);
			
			BigInteger[] times = new BigInteger[N];
			for(int j = 0; j < N; j++) 
			{
				times[j] = new BigInteger(line[j + 1]);
			}
			Arrays.sort(times);

			BigInteger[] subTimes = new BigInteger[N-1];
			for(int j = 0; j < N - 1; j++) 
			{
				subTimes[j] = times[j+1].subtract(times[j]);
			}
			Arrays.sort(subTimes);
			
			BigInteger gcd = BigInteger.ZERO;
			for(int j = 0; j < N - 1; j++) 
			{
				gcd = gcd(subTimes[j], gcd);
			}
			
			BigInteger ans = gcd.subtract(times[0].mod(gcd)).mod(gcd);
			
			output.write("Case #" + (i + 1) + ": " + ans);
			output.newLine();
		}
		
		output.close();
	}
	
	private static BigInteger gcd(BigInteger a, BigInteger b)
	{
		BigInteger t;
		while(b != BigInteger.ZERO)
		{
			t = b;
			b = a.mod(b);
			a = t;
		}
		return a;
	}
}
