import java.util.*;
import java.math.BigInteger;

public class GCJ2 {

	static Scanner sc = new Scanner(System.in);
	public static void main(String[] args) {
		(new GCJ2()).run();
	}

	public void run() {
		int tests = sc.nextInt();
		
		for(int i = 1;i<=tests; ++i) {
			System.out.println("Case #" + i + ":");
			figureOut();
		}
	}
	private void figureOut() {
		int h = sc.nextInt();
		int w = sc.nextInt();
		node[][] nodes = new node[h][w];
		for(int i = 0; i < h; ++i) {
			for(int j = 0; j < w; ++j) {
				nodes[i][j] = new node(sc.nextInt());
			}
		}
		for(int i = 0; i < h; ++i) {
			for(int j = 0; j < w; ++j) {
				node parent=null;
				int height = nodes[i][j].height;
				if(i > 0 && nodes[i-1][j].height < height) {
					parent = nodes[i-1][j];
					height = nodes[i-1][j].height;
				}
				if(j > 0 && nodes[i][j-1].height < height) {
					parent = nodes[i][j-1];
					height = nodes[i][j-1].height;
				}
				if(j < w-1 && nodes[i][j+1].height < height) {
					parent = nodes[i][j+1];
					height = nodes[i][j+1].height;
				}
				if(i < h-1 && nodes[i+1][j].height < height) {
					parent = nodes[i+1][j];
					height = nodes[i+1][j].height;
				}
				if(parent != null) {
					parent.children.add(nodes[i][j]);
					nodes[i][j].hasParent = true;
				}
			}
		}
		Vector<group> groups = new Vector<group>();
		for(int i = 0; i < h; ++i) {
			for(int j = 0; j < w; ++j) {
				if(!nodes[i][j].hasParent) {
					groups.add(new group(nodes[i][j]));
				}
			}
		}
		char letterUpTo = 'a';
		for(int i = 0; i < h; ++i) {
			for(int j = 0; j < w; ++j) {
				if(!nodes[i][j].g.hasLetter) {
					nodes[i][j].g.letter = letterUpTo++;
					nodes[i][j].g.hasLetter = true;
				}
				System.out.print(nodes[i][j].g.letter+" ");
			}
			System.out.println();
		}
	}
}

class node {
	int height;
	boolean hasParent;
	Vector<node> children;
	group g;
	public node(int k) {
		height = k;
		hasParent = false;
		g = null;
		children = new Vector<node>();
	}
}

class group {
	Vector<node> nodes;
	char letter;
	boolean hasLetter = false;
	public group(node n1) {
		Vector<node> currEdge = new Vector<node>();
		currEdge.add(n1);
		Vector<node> nextEdge = new Vector<node>();
		n1.g = this;
		while(!currEdge.isEmpty()) {
			for(node n:currEdge) {
				for(node m:n.children) {
					if(m.g == null) {
						m.g = this;
						nextEdge.add(m);
					}
				}
			}
			currEdge = nextEdge;
			nextEdge = new Vector<node>();
		}
	}
}
