import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class B {
    
    private static double timeUntilX(double x, double prod) {
        return x / prod;
    }
    
    private static double timeUntilFarm(double c, double prod) {
        return c / prod;
    }
    
    private static double timeUntilXBuyingFarm(double c, double f, double x, double prod) {
        return timeUntilFarm(c, prod) + timeUntilX(x, prod + f);
    }
    
    private static double getLowestTime(double c, double f, double x, double prod) {
        if (timeUntilX(x, prod) <= timeUntilXBuyingFarm(c, f, x, prod)) {
            return timeUntilX(x, prod);
        }
        
        return timeUntilFarm(c, prod) + getLowestTime(c, f, x, prod + f); 
    }
    
    private static String getAnswer(double c, double f, double x) {
        double prod = 2; 
        double timeSpent = getLowestTime(c, f, x, prod);
        
        return String.valueOf(timeSpent);
    }

    private static String processCaseInput(BufferedReader br)
            throws IOException {
        String line = br.readLine();
        String[] input = line.split(" ");
        
        double c = Double.valueOf(input[0]);
        double f = Double.valueOf(input[1]);
        double x = Double.valueOf(input[2]);

        return getAnswer(c, f, x);
    }

    public static void main(String[] args) {
        int numCases = 0;

        if (args.length != 1) {
            System.err.println("Input file required for processing");
            System.exit(0);
        }

        // Create the output file
        File outputFile = new File("output.out");
        if (!outputFile.exists()) {
            try {
                outputFile.createNewFile();
            } catch (IOException e) {
                e.printStackTrace();
                System.exit(0);
            }
        }

        // Read input
        try (FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
                BufferedWriter bw = new BufferedWriter(fw);
                BufferedReader br = new BufferedReader(new FileReader(args[0]));) {

            // First line should contain the number of test cases
            String line = br.readLine();
            numCases = Integer.parseInt(line);

            long startTime = System.currentTimeMillis();

            // Following lines should contain test cases
            for (int i = 1; i <= numCases && line != null; i++) {
                String caseAnswer = processCaseInput(br);
                String outputLine = "Case #" + i + ": " + caseAnswer;
                System.out.println(outputLine);
                bw.write(outputLine + "\n");
            }

            long endTime = System.currentTimeMillis();
            System.out.println("Execution time = " + (endTime - startTime));
        } catch (IOException e) {
            System.out.println("Input file not found!");
            e.printStackTrace();
        }
    }
}