package round1b;

import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Scanner;

public class RPI {

	public static int maxS;

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		String fileName = args.length == 0 ? "input.in" : args[0];
		File inputFile = new File(fileName);
		File outputFile = new File(inputFile.getAbsolutePath().replace(".in",
				".out"));
		Scanner scanner = new Scanner(inputFile);

		Writer writer = new FileWriter(outputFile);
		int numCases = Integer.parseInt(scanner.nextLine());

		for (int t = 1; t <= numCases; t++) {
			int numTeams = Integer.parseInt(scanner.nextLine());

			char[][] teams = new char[numTeams][numTeams];

			for (int i = 0; i < numTeams; i++) {
				String line = scanner.nextLine();
				teams[i] = line.toCharArray();
			}

			double[] wp = new double[numTeams];
			int[] numWins = new int[numTeams];
			int[] numPlayed = new int[numTeams];
			double[] owp = new double[numTeams];
			double[] oowp = new double[numTeams];

			double rpi = 0;
			for (int i = 0; i < numTeams; i++) {
				int numWin = 0;
				int total = 0;
				for (int j = 0; j < numTeams; j++) {
					if (teams[i][j] == '1') {
						numWin++;
						total++;
					} else if (teams[i][j] == '0')
						total++;
				}
				numWins[i] = numWin;
				numPlayed[i] = total;
				wp[i] = numWin * 1.0 / total;
			}

			for (int i = 0; i < numTeams; i++) {
				double curOwp = 0;
				int count = 0;
				for (int j = 0; j < numTeams; j++) {
					if (i == j)
						continue;
					if (teams[i][j] == '.')
						continue;

					int win = 0;
					if (teams[i][j] == '0')
						win = numWins[j] - 1;
					else
						win = numWins[j];

					curOwp += win * 1.0 / (numPlayed[j] - 1);
					count++;
				}
				owp[i] = curOwp / count;
			}

			String output = "Case #" + t + ":\n";
			for (int i = 0; i < numTeams; i++) {
				double curOowp = 0;
				int count = 0;
				for (int j = 0; j < numTeams; j++) {
					if (i == j)
						continue;
					if (teams[i][j] == '.')
						continue;
					curOowp += owp[j];
					count++;
				}

				oowp[i] = curOowp / count;
				rpi = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
				output += rpi + "\n";
			}

			System.out.print(output);
			writer.write(output);
		}
		writer.close();
	}
}