//package MagicTrick;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.BitSet;
import java.util.Locale;

public class MagicTrick {
 private BufferedReader in;
 private PrintWriter out;

 final String file = "A-Small";

 public void run() throws IOException {
  in = new BufferedReader(new FileReader(file + ".in"));
  out = new PrintWriter(file + ".out");
  int iNumberofTests = Integer.parseInt(in.readLine());
  String[] firstRow = null;
  String[] secondRow = null;
  for (int i = 0; i < iNumberofTests; i++) {
   int firstChoice = Integer.parseInt(in.readLine());
   for (int j = 0; j < 4; j++) {
    if (j + 1 == firstChoice)
     firstRow = in.readLine().split("\\s+");
    else
     in.readLine();
   }

   int secondChoice = Integer.parseInt(in.readLine());
   for (int j = 0; j < 4; j++) {
    if (j + 1 == secondChoice)
     secondRow = in.readLine().split("\\s+");
    else
     in.readLine();
   }
   out.printf("Case #%d: ", i+1);
   out.printf(solve(firstRow, secondRow));
   out.println();  
  }
  in.close();
  out.close();
 }

 private String solve(String[] firstRow, String[] secondRow) {
  BitSet bs = new BitSet(16);
  // boolean multi = false;
  boolean found = false;
  String val = null;
  for (String s : firstRow)
   bs.set(Integer.parseInt(s) - 1);
  for (String s : secondRow) {
   if (bs.get(Integer.parseInt(s) - 1)) {
    if (!found) {
     found = true;
     val = s;
    } else {
     // multi = true;
     return "Bad magician!";
    }
   }
  }

  if (found)
   return val;
  else
   return "Volunteer cheated!";

 }

 public static void main(String[] args) throws IOException {
  Locale.setDefault(Locale.US);
  new MagicTrick().run();
 }

}