package qr2014;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;
import java.util.TreeSet;

public class DeceitfulWar {
	private static final String PATH = "src\\ressources";
	private static final String PROBLEM = "D";
	private static final String VERSION = "small-attempt0";//"small-attempt0"; //large
	private static final String EXT_IN = "in";
	private static final String EXT_OUT = "out";
	
	public String solve(Scanner in) {
		int nbBlocks = in.nextInt();
		
		TreeSet<Double> naoSetDeceitful = new TreeSet<Double>();
		TreeSet<Double> kenSetDeceitful = new TreeSet<Double>();
		TreeSet<Double> naoSetWar = new TreeSet<Double>();
		TreeSet<Double> kenSetWar = new TreeSet<Double>();
		
		double tmp;
		
		for(int i = 0; i < nbBlocks; i++) {
			tmp = in.nextDouble();
			naoSetDeceitful.add(new Double(tmp));
			naoSetWar.add(new Double(tmp));
		}
		for(int i = 0; i < nbBlocks; i++) {
			tmp = in.nextDouble();
			kenSetDeceitful.add(new Double(tmp));
			kenSetWar.add(new Double(tmp));
		}
		
		int naoDeceitful = 0;
		
		int size = kenSetDeceitful.tailSet(naoSetDeceitful.last(), false).size();
		for(int i = 0; i < size; i++) {
			naoSetDeceitful.pollFirst();
			kenSetDeceitful.pollLast();
		}

		Double val;
		
		while(!kenSetDeceitful.isEmpty()) {
			val = naoSetDeceitful.higher(kenSetDeceitful.last());
			if(val != null) {
				naoSetDeceitful.remove(val);
				kenSetDeceitful.pollLast();
				naoDeceitful++;
			} else {
				naoSetDeceitful.pollFirst();
				kenSetDeceitful.pollLast();
			}
		}
		
		
		size = naoSetWar.tailSet(kenSetWar.last(), false).size();
		int naoWar = size;
		for(int i = 0; i < size; i++) {
			kenSetWar.pollFirst();
			naoSetWar.pollLast();
		}
		
		while(!naoSetWar.isEmpty()) {
			val = kenSetWar.higher(naoSetWar.last());
			if(val != null) {
				kenSetWar.remove(val);
				naoSetWar.pollLast();
				
			} else {
				kenSetWar.pollFirst();
				naoSetWar.pollLast();
				naoWar++;
			}
		}
		
		return String.valueOf(naoDeceitful) + " " + String.valueOf(naoWar);
	}
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(getCompletPath(EXT_IN)));
		in.useLocale(Locale.US);
		PrintWriter out = new PrintWriter(new FileWriter(getCompletPath(EXT_OUT)));
		
		int nbTestCase = in.nextInt();
		DeceitfulWar dw = new DeceitfulWar();
		for(int i = 0; i < nbTestCase; i++) {
			out.println("Case #" + (i+1) + ": " + dw.solve(in));
			out.flush();
		}
		
		in.close();
		out.close();
	}
	
	private static String getCompletPath(String ext) {
		return PATH + "\\" + PROBLEM + "-" + VERSION + "." + ext;
	}
}
