package com.google.codejam.practice2012.qualificationRound;

import com.google.codejam.abs.Problem;
import com.google.codejam.utils.files.ManejoArchivos;

import java.io.FileNotFoundException;
import java.io.IOException;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class DancingWithTheGooglers extends Problem {
    public DancingWithTheGooglers(String name) throws FileNotFoundException, 
                                                      IOException {
        super(name);
    }

    public static void main(String[] args) throws FileNotFoundException, 
                                                  IOException {
        //new DancingWithTheGooglers("DancingWithTheGooglers-Sample");
        new DancingWithTheGooglers("DancingWithTheGooglers-Small");
        //new DancingWithTheGooglers("DancingWithTheGooglers-Large");
    }

    public String execCase() throws IOException {
        int[] dataset = ManejoArchivos.getInts();
        int googlers = dataset[0];
        int surprises = dataset[1];
        int scoreP = dataset[2];
        
        if( scoreP == 0 ) {
            return "" + googlers;
        }
        
        int[] totalScores = Arrays.copyOfRange(dataset, 3, dataset.length);
        Arrays.sort(totalScores);
        int[][] googlersScores = new int[googlers][];
        
        boolean allBetters = true;
        for(int i=0;i<googlers;i++) {
            googlersScores[i] = calculateScoresNoSurprise(totalScores[i]);
            allBetters &= isIntoBetters(googlersScores[i], scoreP);
        }
        
        if( !allBetters ) {
            for(int i=googlersScores.length-1;i>=0 && surprises>0;i--) {
                if( !isIntoBetters(googlersScores[i], scoreP) &&
                        !isSurprise(googlersScores[i]) &&
                        totalScores[i] > 1 ) {
                    convert2Surprise(googlersScores[i]);
                    surprises--;
                }
            }
            
            if( surprises != 0 ) {
                System.out.println("no cumplio las sorpresas");
            }
        } else {
            System.out.println("todos son mejores");
        }
        
        int betters = 0;
        for(int i=0;i<googlers;i++) {
            if( isIntoBetters(googlersScores[i], scoreP) ) {
                betters++;
            }
        }
        return "" + betters;
    }
    
    private int[] calculateScoresNoSurprise(int totalScore) {
        int simpleScore = totalScore / 3;
        int[] scores = new int[] { simpleScore, simpleScore, simpleScore };
        
        int dif = totalScore - (simpleScore * 3);
        for(int i=0;i<dif;i++) {
            scores[i]++;
        }
        
        return scores;
    }
    
    private void convert2Surprise(int[] googlerScore) {
        if( googlerScore[0] == googlerScore[1] && googlerScore[0] == googlerScore[2] ) {
            googlerScore[0]++;
            googlerScore[2]--;
        } else if( googlerScore[0] == googlerScore[1] ) {
            googlerScore[0]++;
            googlerScore[1]--;
        } else {
            googlerScore[1]++;
            googlerScore[2]--;
        }

        if( !isSurprise(googlerScore) ) {
            convert2Surprise(googlerScore);
        }
    }
    
    private boolean isSurprise(int[] googlerScore) {
        int dif = googlerScore[0] - googlerScore[1];
        dif += googlerScore[0] - googlerScore[2];
        
        if( dif <= 2 ) {
            return false;
        } else {
            return true;
        }
    }
    
    private boolean isIntoBetters(int[] googlerScore, int better) {
        for(int i=0;i<googlerScore.length;i++) {
            if( googlerScore[i] >= better ) {
                return true;
            }
        }
        return false;
    }
}
