import java.io.*;
import java.util.StringTokenizer;

public class FairAndSquare {

  public long find(long start, long end) {
    long count = 0;

    //only need to check from sqrt(start) until sqrt(end)
    start = (long) Math.ceil(Math.sqrt(start)); //start with next long to ensure the square is large enough
    end = (long) Math.sqrt(end);

    for (long i=start; i<=end; i++) {
      if (isPalindrome(i)) {
        if (isPalindrome(i*i)) {
          //System.out.println(i+" -> "+i*i);
          count++;
        }
      }
    }

    return count;
  }

  public boolean isPalindrome(long n) {
    long reverse=0;
    long original=n;

    while (n>0) {
      reverse = reverse * 10 + n % 10;
      n/=10;
    }

    return reverse==original;
  }

  public static void main(String[] args) throws IOException {
    BufferedReader in = new BufferedReader(new FileReader("FairAndSquare.in"));
    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("FairAndSquare.out")));

    int cases = Integer.parseInt(in.readLine());
    for (int i=0; i<cases; i++) {
      StringTokenizer st = new StringTokenizer(in.readLine());
      long start = Long.parseLong(st.nextToken());
      long end = Long.parseLong(st.nextToken());

      long result = new FairAndSquare().find(start, end);
      out.println("Case #"+(i+1)+": "+result);
    }
    in.close();
    out.close();
  }
}