/**
 * @author Maxim Degtyarev <mdegtyarev@gmail.com>
 */
import java.io.*;
import java.util.*;

public class ProblemB {

    private final Scanner input;
    private final PrintStream output;

	private static final double EPSYLON = 10E-6;

	private double calculateTime(double cps, double goal) {
		return (goal / cps);
	}
	
    private String solveCase() {
		// C
		double farmPrice = input.nextDouble();
		// F
		double speedBoost = input.nextDouble();
		// X
		double goal = input.nextDouble();

		double currentSpeed = 2.0;
		double farmTime = 0;
		double bestTime = calculateTime(2, goal);

		while(true) {
			farmTime += calculateTime(currentSpeed, farmPrice);
			currentSpeed += speedBoost;
			double newTime = farmTime + calculateTime(currentSpeed, goal);

			if (newTime > bestTime)
				break;

			bestTime = newTime;

		}

		return Double.toString(bestTime);
    }

    private void invoke() {
        int caseCount = input.nextInt();

        String rest = input.nextLine();

        assert rest.length() == 0 : rest;

        String result;
        for(int caseNumber = 1; caseNumber <= caseCount; caseNumber++) {
            result = solveCase();
            output.printf("Case #%d: %s\n", caseNumber, result);
        }        
    }
    
    private ProblemB(InputStream input, PrintStream output) {
        this.input = new Scanner(input);
		this.input.useLocale(Locale.ROOT);
        this.output = output;
    }     
    
    public static void main(String... args) throws FileNotFoundException {

        InputStream inputStream;
        PrintStream outputStream;
        
        if (args.length > 0) {
            
            final String inputFileName = args[0];
            final String outputFileName;
            
            if (inputFileName.endsWith(".in")) {
                outputFileName = inputFileName.substring(0, inputFileName.length() - 3) + ".out";
            } else {
                outputFileName = inputFileName + ".out";
            }

            inputStream = new FileInputStream(inputFileName);
            outputStream = new PrintStream(outputFileName);

        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        
        ProblemB instance = new ProblemB(inputStream, outputStream);
        
        instance.invoke();        
    }

}
