package com.google.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class Wires {
	
	public int crossProduct(int x1, int y1, int x2, int y2) {
		return x1*y2-x2*y1;
	}
	
	public int crossProduct(int x0, int y0, int x1, int y1, int x2, int y2) {
		return crossProduct(x1-x0, y1 - y0, x2 -x0, y2 - y0);
	}
	
	public boolean intersect(int a1, int b1, int a2, int b2) {
		int x1 = 1;
		int x2 = 2;
		int y1 = a1;
		int y2 = b1;
		int x3 = 1;
		int x4 = 2;
		int y3 = a2;
		int y4 = b2;
		
		int d1 = crossProduct(x3, y3, x4, y4, x1, y1);
		int d2 = crossProduct(x3, y3, x4, y4, x2, y2);
		int d3 = crossProduct(x1, y1, x2, y2, x3, y3);
		int d4 = crossProduct(x1, y1, x2, y2, x4, y4);
		
		return ((d1 > 0 && d2 < 0) || (d1 < 0 && d2 > 0)) && 
		   ((d3 >0 && d4 < 0) || (d3 < 0 && d4 > 0)); 
	}
	

	public void solve(File inFile, File outFile) throws IOException {		 
		BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream(inFile)));
		PrintWriter w = new PrintWriter(outFile);
		int T = Integer.parseInt(r.readLine().trim());
	
		
		for(int t = 0; t < T; t++) {
			String line = r.readLine().trim();
			int n = Integer.parseInt(line);
			int[] a = new int[n];
			int[] b = new int[n];
			for(int i = 0; i < n; i++) {
				line = r.readLine().replace("  ", " ").trim();
				String[] items = line.split(" ");
				a[i] = Integer.parseInt(items[0]);
				b[i] = Integer.parseInt(items[1]);
			}
			long count = 0;
			for(int i = 0; i < n; i++) {
				for(int j = i+1; j < n; j++) {
					if (intersect(a[i],b[i], a[j],b[j])) {
						count++;
					}
				}
			}
			w.println(String.format("Case #%d: %d", t+1, count));
		}
		w.close();
		r.close();
	}
	
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		File in = new File("c:/temp/codejam/A-small-attempt2.in");
		File out = new File("c:/temp/codejam/A.out");
		
		Wires w = new Wires();
		w.solve(in, out);
		

	}

}
