import java.util.*;

// 2014 Round 3 solution 1
public class R3S1 {
    static Scanner in;

    public static void main(String[] args) {
        in = new Scanner(System.in);
        final int testCases = in.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            new Solution(testCase);
        }
    }

    public static class Solution {
        Solution(int testCase) {
            int numFiles = in.nextInt();
            int diskCapacity = in.nextInt();

            // Never place more than two files on the same disk
            // Never divide a single file over multiple disks

            Deque<Integer> fileSizes = new LinkedList<Integer>();

            for (int i = 0; i < numFiles; i++) {
                fileSizes.add(in.nextInt());
            }

            int usedDisks = 0;

            Collections.sort((List)fileSizes);
            Collections.reverse((List) fileSizes);

            while (fileSizes.size() > 0) {
                int high = fileSizes.removeFirst();

                for (int low : fileSizes) {
                    if (high + low <= diskCapacity) {
                        fileSizes.remove((Integer)low);
                        break;
                    }
                }

                usedDisks++;
            }

            System.out.println("Case #" + testCase + ": " + usedDisks);
        }
    }
}
