import java.io.*;
import java.util.StringTokenizer;

public class BotTrust
{
	public static void main( String[] args ) throws IOException
	{
		StringTokenizer line;
		BufferedReader br = null;
		PrintWriter pw = null;
		if( args.length >= 2 )
		{
			FileReader fr = new FileReader( args[0] );
			br = new BufferedReader(fr);
			
			FileWriter fw = new FileWriter( args[1] );
			pw = new PrintWriter(fw);
		}
		else
		{
			System.exit(0);
		}
		
		int n;	//number of buttons
		
		int testCases = Integer.parseInt(br.readLine());
		for( int i=0; i<testCases; i++ )
		{
			line = new StringTokenizer( br.readLine() );
			n = Integer.parseInt(line.nextToken());

			int[][] pos = new int[2][n+1];
			pos[0][0] = 1;
			pos[1][0] = 1;
			int[] time = new int[n+1];
			int travTime = 0;
			int prevJ = 0;
			for( int j=1; j<=n; j++ )
			{
				String t = line.nextToken();
				int idx;
				if( t.equals("O") ) 
					idx = 0;
				else 
					idx = 1;
				t = line.nextToken();
				int btn = Integer.parseInt(t);	
				
				/* get prev event index for robot */
				prevJ = j-1;
				while( prevJ > 0 )
				{
					if( pos[idx][prevJ] != 0 )
						break;
					prevJ--;
				}
				pos[idx][j] = btn;
				travTime = Math.abs(pos[idx][j] - pos[idx][prevJ]);
				if( travTime < time[j-1] - time[prevJ] )
				{
					time[j] = time[j-1] + 1;
				}
				else
				{
					time[j] = time[prevJ] + travTime + 1;
				}
			}
			pw.print("Case #" + (i+1) + ": " + time[n] + "\n" );
		}
		pw.close();
		br.close();
	}
}