package candysplit;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Hashtable;

public class CandySplit
{

	public static void main(String[] args) throws NumberFormatException, IOException
	{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int count = Integer.parseInt(br.readLine());
		
		int[] results = new int[count];
		
		for(int i = 0;i < count;i++)
		{
			int valCount = Integer.parseInt(br.readLine());
			
			int[] vals = new int[valCount];
			
			String[] sVals = br.readLine().split(" ");
			
			for(int j = 0;j < valCount;j++)
				vals[j] = Integer.parseInt(sVals[j]);
			
			CandySplit cs = new CandySplit(vals);
			results[i] = cs.solve();
		}
		
		for(int i = 0;i < results.length;i++)
		{
			System.out.println("Case #" + (i + 1) + ": " + (results[i]==-1?"NO":results[i]));
		}
	}
	
	public CandySplit(int[] values)
	{
		this.values = values;
	}
	
	int[] values;
	
	Hashtable<State, Integer> lookupTable = new Hashtable<State, Integer>();
	
	public int solve()
	{
		return solve(new State(0, 0, 0, false));
	}
	
	public int solve(State s)
	{
		if(lookupTable.containsKey(s))
		{
			return lookupTable.get(s);
		}
		
		int value = -1;
		
		if(s.idx == values.length)
		{
			if(s.patHas && s.patVal == s.seanVal)
				value = 0;
		}
		else
		{
			int tp = s.patVal ^ values[s.idx];
			int ts = s.seanVal ^ values[s.idx];
			
			{
				int valueP = solve(new State(s.idx + 1, tp, s.seanVal, true));
				int valueS = solve(new State(s.idx + 1, s.patVal, ts, s.patHas));
				
				if(valueP == -1)
				{
					if(valueS != -1)
						value = valueS + values[s.idx];
				}
				else if(valueS == -1)
				{
					value = valueP;
				}
				else
				{
					value = Math.max(valueP, valueS + values[s.idx]);
				}
			}
			lookupTable.put(s, value);
		}
		return value;
	}
	
	public class State
	{
		int idx;
		int patVal;
		int seanVal;
		boolean patHas;
		
		public State(int idx, int patVal, int seanVal, boolean patHas)
		{
			this.idx = idx;
			this.patVal = patVal;
			this.seanVal = seanVal;
			this.patHas = patHas;
		}
		
		public int hashCode()
		{
			return idx ^ (patVal << 10) ^ (seanVal << 20) & (patHas?1<<31:0);
		}
		
		public boolean equals(State s)
		{
			return s.idx == idx && s.patVal == patVal && s.seanVal == seanVal && s.patHas == patHas;
		}
	}
	
}
