import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class KillerWord {
	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int T = Integer.parseInt(scan.nextLine());

		for (int i = 0; i < T; i++) {
			Map <Integer, List <String>> dictionary = new HashMap <Integer, List <String>>();
			Map <String, Integer> indices = new HashMap <String, Integer>();
			List <String> orderings = new ArrayList <String>();
			
			int N = scan.nextInt();
			int M = scan.nextInt();
			scan.nextLine();
			
			int index = 0;
			for (int j = 0; j < N; j++) {
				String word = scan.nextLine();
				if (!dictionary.containsKey(word.length())) {
					dictionary.put(word.length(), new LinkedList <String>());
				}
				indices.put(word, index++);
				dictionary.get(word.length()).add(word);
			}
			for (int j = 0; j < M; j++) {
				orderings.add(scan.nextLine());
			}
			
			String response = "Case #" + (i + 1) + ": "; 
			for (String ordering : orderings) {
				WordPair best = new WordPair("", -1);
				for (int j : dictionary.keySet()) {
					WordPair temp  = computeScore(dictionary.get(j), ordering, 0, 0, indices);
					if (temp.score > best.score || (temp.score == best.score && indices.get(temp.word) < indices.get(best.word))) {
						best.score = temp.score;
						best.word = temp.word;
					}
				}
				response += best.word + " ";
			}
			System.out.println(response.substring(0, response.length() - 1));
		}
	}

	private static WordPair computeScore(List <String> words, String ordering, int position, int score, Map <String, Integer> indices) {
		if (words.size() == 0) {
			return new WordPair("", 0);
		} else if (words.size() == 1) {
			return new WordPair(words.get(0), score);
		}

		Map <String, List <String>> guess = new HashMap <String, List <String>>();
		for (String s : words) {
			String sub = s.replaceAll("[^" + ordering.charAt(position) + "]", "-");
			if (!guess.containsKey(sub)) {
				guess.put(sub, new LinkedList <String>());
			}
			guess.get(sub).add(s);
		}

		if (guess.size() == 1) {
			return computeScore(words, ordering, position + 1, score, indices);
		}

		WordPair best = new WordPair(words.get(0), 0);
		for (String possibility : guess.keySet()) {
			List <String> candidates = guess.get(possibility);
			String word = possibility.replaceAll("-*", "");
			
			if (candidates.size() == 1) {
				if (word.length() == 0) {
					if (score >= best.score) {
						best.score = score + 1;
						best.word = candidates.get(0);
					} else if (score == best.score - 1 && indices.get(candidates.get(0)) < indices.get(best.word)) {
						best.score = score + 1;
						best.word = candidates.get(0);
					}
				} else if (score > best.score || (score == best.score && indices.get(candidates.get(0)) < indices.get(best.word))) {
					best.score = score;
					best.word = candidates.get(0);
				}
			} else {
				WordPair next = computeScore(candidates, ordering, position + 1, word.length() == 0 ? score + 1 : score, indices);
				if (next.score > best.score || (next.score == best.score && indices.get(next.word) < indices.get(best.word))) {
					best.score = next.score;
					best.word = next.word;
				}
			}
		}
		return best;
	}

	private static class WordPair {
		public String word;
		public int score;

		public WordPair(String word, int score) {
			this.word = word;
			this.score = score;
		}
	}
}
