import java.util.*;

public class ProblemB {
	public static void main(String... args) {
		for (DataSet dataSet : new DataSets())
			handleDataSet(dataSet);
	}


	private static void handleDataSet(DataSet dataSet) {
		System.out.println(
			"Case #" + dataSet.number + ": " + dataSet.getResult());
	}

	public static class DataSet {
		public final long number;
		private final int[][] lawn;

		public DataSet(long number, int[][] lawn) {
			this.number = number;
			this.lawn = lawn;
		}

		public String getResult() {
			int[] rowMax = new int[lawn.length];
			for (int i = 0; i < rowMax.length; ++i)
				for (int j = 0; j < lawn[i].length; ++j)
					rowMax[i] = Math.max(rowMax[i], lawn[i][j]);
			int m = lawn[0].length;
			int[] colMax = new int[m];
			for (int j = 0; j < m; ++j)
				for (int i = 0; i < lawn.length; ++i)
					colMax[j] = Math.max(colMax[j], lawn[i][j]);
			/*	
			for (int[] row : lawn) {
				String x = "";
				for (int field : row)
					x += " " + field;
				System.out.println(x);
			}*/
			for (int i = 0; i < lawn.length; ++i)
				for (int j = 0; j < m; ++j)
					if ((lawn[i][j] != rowMax[i]) && (lawn[i][j] != colMax[j]))
						return "NO";
			return "YES";
		}
	}

	public static class DataSets implements Iterable<DataSet> {
		public Iterator<DataSet> iterator() {
			return new DataSetsIterator();
		}		
	}

	public static class DataSetsIterator implements Iterator<DataSet> {
		private final long numberOfDataSets;
		private final Scanner sc;
		private long indexOfCurrentDataSet; //zero based

		public DataSetsIterator() {
			sc = new Scanner(System.in);
			numberOfDataSets = sc.nextLong();
			sc.nextLine();
			indexOfCurrentDataSet = 0;
		}

		public boolean hasNext() {
			return indexOfCurrentDataSet < numberOfDataSets;
		}

		public DataSet next() {
			int n = sc.nextInt();
			int m = sc.nextInt();
			sc.nextLine();
			int[][] lawn = new int[n][];
			for (int i = 0; i < n; ++i) {
				lawn[i] = new int[m];
				for (int j = 0; j < m; ++j)
					lawn[i][j] = sc.nextInt();
				sc.nextLine();
			}
			DataSet dataSet = new DataSet(indexOfCurrentDataSet + 1, lawn);
			++indexOfCurrentDataSet;
			return dataSet;
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
