import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FairAndSquare {

	private boolean isPalindrome(int num) {
		String numString = Integer.toString(num);
		String reversedNumString = new StringBuffer().append(numString)
				.reverse().toString();
 
		return numString.equals(reversedNumString);
	}

	private boolean isSquareOfPalindrome(int num) {
		double sqrt = Math.sqrt(num);

		// Check if the sqrt is a round number
		if (sqrt == Math.rint(sqrt)) {
			return isPalindrome((int) sqrt);
		} else {
			return false;
		}
	}

	private String process(int rangeStart, int rangeEnd) {
		int numFairAndSquare = 0;

		// Test each number in the range
		for (int i = rangeStart; i <= rangeEnd; i++) {
			if (isPalindrome(i) && isSquareOfPalindrome(i)) {
				numFairAndSquare++;
			}
		}

		return Integer.toString(numFairAndSquare);
	}

	public static void main(String[] args) {
		FairAndSquare fas = new FairAndSquare();

		if (args.length == 1) {
			BufferedReader br = null;
			int numCases = 0;

			try {
				// Create the output file
				File outputFile = new File("output.out");
				if (!outputFile.exists()) {
					outputFile.createNewFile();
				}

				FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
				BufferedWriter bw = new BufferedWriter(fw);

				// Read input
				br = new BufferedReader(new FileReader(args[0]));

				// First line should contain the number of test cases
				String line = br.readLine();
				numCases = Integer.parseInt(line);

				long startTime = System.currentTimeMillis();

				// Following lines should contain test cases
				for (int i = 1; i <= numCases && line != null; i++) {
					line = br.readLine();
					String[] rangeNums = line.split(" ");
					int start = Integer.parseInt(rangeNums[0]);
					int end = Integer.parseInt(rangeNums[1]);

					String outputLine = "Case #" + i + ": "
							+ fas.process(start, end);
					System.out.println(outputLine);
					bw.write(outputLine + "\n");
				}

				long endTime = System.currentTimeMillis();

//				System.out.println("Execution time = " + (endTime - startTime));

				br.close();
				bw.close();
			} catch (IOException e) {
				System.out.println("Input file not found!");
				e.printStackTrace();
			}
		} else {
			System.err.println("Input file required for processing");
		}
	}
}
