/**
 * @author Maxim Degtyarev <mdegtyarev@gmail.com>
 */
import java.io.*;
import java.util.*;

public class ProblemA {

    private final Scanner input;
    private final PrintStream output;


	private static final String BAD_MAGICIAN = "Bad magician!";
	private static final String VOLUNTEER_CHEATED = "Volunteer cheated!";

    private String solveCase() {

		int firstAnswer = input.nextInt() - 1;
		int[][] firstArrangement = new int[4][4];
		for(int i = 0; i < 4; i++) {
			for(int j = 0; j < 4; j++) {
				firstArrangement[i][j] = input.nextInt();
			}
		}

		int secondAnswer = input.nextInt() - 1;
		int[][] secondArrangement = new int[4][4];
		for(int i = 0; i < 4; i++) {
			for(int j = 0; j < 4; j++) {
				secondArrangement[i][j] = input.nextInt();
			}
		}

		Set<Integer> firstSet = new HashSet<Integer>(4);
		Set<Integer> secondSet = new HashSet<Integer>(4);

		for(int i = 0; i < 4; i++) {
			firstSet.add(firstArrangement[firstAnswer][i]);
		}

		for(int i = 0; i < 4; i++) {
			secondSet.add(secondArrangement[secondAnswer][i]);
		}

		firstSet.retainAll(secondSet);

		Integer[] intersection = new Integer[firstSet.size()];
		firstSet.toArray(intersection);

		switch(intersection.length) {
			case 0:
				return VOLUNTEER_CHEATED;
			case 1:
				return Integer.toString(intersection[0]);
			default:
				return BAD_MAGICIAN;
		}

    }

    private void invoke() {
        int caseCount = input.nextInt();

        String rest = input.nextLine();

        assert rest.length() == 0 : rest;

        String result;
        for(int caseNumber = 1; caseNumber <= caseCount; caseNumber++) {
            result = solveCase();
            output.printf("Case #%d: %s\n", caseNumber, result);
        }        
    }
    
    private ProblemA(InputStream input, PrintStream output) {
        this.input = new Scanner(input);
        this.output = output;
    }     
    
    public static void main(String... args) throws FileNotFoundException {

        InputStream inputStream;
        PrintStream outputStream;
        
        if (args.length > 0) {
            
            final String inputFileName = args[0];
            final String outputFileName;
            
            if (inputFileName.endsWith(".in")) {
                outputFileName = inputFileName.substring(0, inputFileName.length() - 3) + ".out";
            } else {
                outputFileName = inputFileName + ".out";
            }

            inputStream = new FileInputStream(inputFileName);
            outputStream = new PrintStream(outputFileName);

        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        
        ProblemA instance = new ProblemA(inputStream, outputStream);
        
        instance.invoke();        
    }

}
