package codejam2;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Comparator;
import java.util.Arrays;

/**
 *
 * @author sebi
 */
class Event implements Comparator<Event> {
    public static final char ARRIVE = 'A';
    static int turnaround;
    int h, m, st;
    char type;
    String ev;

    Event() {
    }

    Event(String in, char type, int st) {
        this.h = Integer.parseInt(in.substring(0, 2));
        this.m = Integer.parseInt(in.substring(3));
        this.st = st;
        this.type = type;
        if (type == ARRIVE) {
            this.m += turnaround;
            this.h += this.m / 60;
            this.m %= 60;
        }
        this.ev = "";
        if (this.h < 10) {
            this.ev += "0" + this.h;
        } else {
            this.ev += this.h;
        }
        this.ev += ":";
        if (this.m < 10) {
            this.ev += "0" + this.m;
        } else {
            this.ev += this.m;
        }
        this.ev += (char) type;
        this.ev += st;
    }

    public int compare(Event o1, Event o2) {
        return o1.ev.compareTo(o2.ev);
    }
}

public class Main {
    public static final char ARRIVE = 'A';
    public static final char DEPART = 'D';

    public static void main(String[] args) throws IOException {
        Event cc = new Event();
        Event[] events;
        Scanner in = new Scanner(new FileReader("B-small.in"));
        PrintWriter out = new PrintWriter(new FileWriter("B-small-out.out"));
        int T = Integer.parseInt(in.nextLine());
        int cs = 1, i, ev;
        int na, nb;
        String[] s = new String[2];
        String line;
        while (cs <= T) {
            Event.turnaround = Integer.parseInt(in.nextLine());
            na = in.nextInt();
            nb = in.nextInt();
            in.nextLine();
            events = new Event[2 * (na + nb)];
            ev = 0;
            for (i = 0; i < na; i++) {
                line = in.nextLine();
                s = line.split(" ");
                events[ev++] = new Event(s[0],DEPART, 1); //DEPART
                events[ev++] = new Event(s[1],ARRIVE, 2); //ARRIVE
            }
            for (i = 0; i < nb; i++) {
                line = in.nextLine();
                s = line.split(" ");
                events[ev++] = new Event(s[0],DEPART, 2);
                events[ev++] = new Event(s[1],ARRIVE, 1);
            }
            Arrays.sort(events, cc);
            System.out.println("#" + cs);
            for (i = 0; i < ev; i++) {
                System.out.println(events[i].ev);
            }

            int trainsInA = 0, trainsInB = 0, A = 0, B = 0;
            for (i = 0; i < ev; i++) {
                if (events[i].type == ARRIVE) {
                    if (events[i].st == 1) {
                        trainsInA++;
                    } else {
                        trainsInB++;
                    }
                } else {
                    if (events[i].st == 1) {
                        if (trainsInA > 0) {
                            trainsInA--;
                        } else {
                            A++;
                        }
                    } else if (trainsInB > 0) {
                        trainsInB--;
                    } else {
                        B++;
                    }
                }
            }

            out.printf("Case #%d: %d %d%n", cs, A, B);
            if (A + B != trainsInA + trainsInB) {
                System.out.println("!!!");
            }
            cs++;
        }
        in.close();
        out.close();
    }
}
