package com.google.jam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class Jamcode {
	
	
	private static BigInteger gcd(BigInteger[] x) {
		if (x.length == 1) {
			return x[0];
		}
		BigInteger gcd = x[0].gcd(x[1]);
		for(int i = 2; i < x.length; i++) {
			gcd = gcd.gcd(x[i]);
		}
		return gcd;	
	}			
	
	private static boolean checkY(BigInteger[] t, BigInteger y, BigInteger T) {
		for(BigInteger tt : t) {
			BigInteger remainder = tt.add(y).divideAndRemainder(T)[1];
			if (remainder.compareTo(BigInteger.ZERO) != 0) {
				return false;
			}
		}
		return true;
	}
	
	private static BigInteger solve(BigInteger[] t) {
		List<BigInteger> deltas = new ArrayList<BigInteger>();
		for(int i = 0; i < t.length-1; i++) {
			for(int j = i+1; j < t.length; j++) {
				BigInteger delta = t[i].subtract(t[j]).abs();
				deltas.add(delta);
			}
		}
		BigInteger T = gcd(deltas.toArray(new BigInteger[0]));
		if (T.compareTo(BigInteger.ONE) <= 0) {
			return new BigInteger("0");
		}
		
		BigInteger max = t[0];
		for(BigInteger tt : t) {
			if (max.compareTo(tt) < 0) {
				max = tt;
			}
		}
		BigInteger best = null;		
		for(BigInteger x = t[0].divide(T); x.compareTo(max) <= 0; x = x.add(BigInteger.ONE)) {
			BigInteger tPlusY = x.multiply(T);
			BigInteger y = tPlusY.subtract(t[0]);
			if (y.compareTo(BigInteger.ZERO) < 0) {
				continue;
			}
			if (checkY(t, y, T)) {
				return y;
			}
		}
		if (best == null) {
			best = new BigInteger("0");
		}
		return best;
	}
	
	public static void main(String[] args) throws Exception {
		File inFile = new File("/home/thexman/Download/B-small-attempt0.in");
		//File inFile = new File("/tmp/input.txt");
		File outFile = new File("/home/thexman/B.out");		
		BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream(inFile)));
		PrintWriter w = new PrintWriter(new FileOutputStream(outFile));
		String line = r.readLine().trim();
		int c = Integer.parseInt(line);
		for(int i = 0; i < c; i++){			
			line = r.readLine().trim().replaceAll("  ", " ");			
			String[] items = line.split(" ");
			int n = Integer.parseInt(items[0]);
			BigInteger[] t = new BigInteger[n];
			for(int j = 0; j < n; j++) {
				t[j] = new BigInteger(items[j+1]);
			}
			
			String result = String.format("Case #%d: %s", i+1, solve(t)); 
			w.println(result);
			System.out.println(result);
		}
		
		w.close();
		r.close();
	}
}
