package basket;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Basket
{

	public static void main(String[] args) throws NumberFormatException, IOException
	{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int count = Integer.parseInt(br.readLine());
		
		for(int i = 0;i < count;i++)
		{
			int teams = Integer.parseInt(br.readLine());
			
			char[][] standings = new char[teams][teams];
			
			for(int team = 0;team < teams;team++)
			{
				standings[team] = br.readLine().toCharArray();
			}
			
			double[] RPI = solveRPI(standings);
			
			System.out.println("Case #" + (i + 1) + ":");
			for(double r : RPI)
				System.out.println(r);
		}
	}
	
	public static double[] solveRPI(char[][] standings)
	{
		int[] wins = new int[standings.length];
		int[] total = new int[standings.length];
		float[] OWP = new float[standings.length];
		float[] OOWP = new float[standings.length];
		
		double[] RPI = new double[standings.length];
		
		for(int team = 0;team < standings.length;team++)
		{
			for(int i = 0;i < standings[team].length;i++)
			{
				switch(standings[team][i])
				{
				case '1':
					wins[team]++;
				case '0':
					total[team]++;
				}
			}
			//System.out.println("Team Win Ratio: " + wins[team] + " / " + total[team]);
		}
		
		for(int team = 0;team < standings.length;team++)
		{
			OWP[team] = 0f;
			int count = 0;
			
			for(int i = 0;i < standings[team].length;i++)
			{
				int win = wins[i];
				int tot = total[i] - 1;
				
				if(standings[i][team] == '1')
					win--;
					
				if(standings[team][i] != '.')
				{
					count++;
					OWP[team] += ((float) win / (float) tot);
					//System.out.println("OWP (Team: " + team + " -> " + i + ") " + win + " / " + tot);
				}
				
			}
			OWP[team] /= (float) count;
			//System.out.println("OWP Total (Team: " + team + "): " + OWP[team]);
		}
		
		for(int team = 0;team < standings.length;team++)
		{
			OOWP[team] = 0f;
			int count = 0;
			for(int i = 0;i < standings[team].length;i++)
			{
				if(standings[team][i] != '.')
				{
					count++;
					OOWP[team] += OWP[i];
				}
			}
			OOWP[team] /= (float) count;
			//System.out.println("OOWP (Team: " + team + "): " + OOWP[team]);
		}
		
		for(int team = 0;team < standings.length;team++)
		{
			RPI[team] = 0.25 * ((float) wins[team] / (float) total[team]) + 0.5 * OWP[team] + 0.25 * OOWP[team];
		}
		return RPI;
	}
	
}
