import java.math.*;
import java.util.*;

public class Problem {
	public static void main(String... args) {
		Locale.setDefault(Locale.ENGLISH);
		for (DataSet dataSet : new DataSets())
			handleDataSet(dataSet);
	}


	private static void handleDataSet(DataSet dataSet) {
		System.out.println(
			"Case #" + dataSet.number + ": " + dataSet.getResult());
	}

	public static class DataSet {
		public long number;
		public double c,f,x;

		public String getResult() {
			double currentRate = 2d;
			double elapsedTime = 0d;
			while (true) {
				double timeNecessaryWithoutChange = x / currentRate;
				double timeToBuildFabric = c / currentRate;
				if (timeToBuildFabric >= timeNecessaryWithoutChange)
					return Double.toString(elapsedTime + timeNecessaryWithoutChange);
				else {
					double timeForAmortisation = c / f;
					if ((timeToBuildFabric + timeForAmortisation) >= timeNecessaryWithoutChange)
						return Double.toString(elapsedTime + timeNecessaryWithoutChange);
					else {
						currentRate += f;
						elapsedTime += timeToBuildFabric;
					}
				}
			}
		}
	}

	public static class DataSets implements Iterable<DataSet> {
		public Iterator<DataSet> iterator() {
			return new DataSetsIterator();
		}		
	}

	public static class DataSetsIterator implements Iterator<DataSet> {
		private final long numberOfDataSets;
		private final Scanner sc;
		private long indexOfCurrentDataSet; //zero based

		public DataSetsIterator() {
			sc = new Scanner(System.in);
			numberOfDataSets = sc.nextLong();
			nextLine();
			indexOfCurrentDataSet = 0;
		}

		public boolean hasNext() {
			return indexOfCurrentDataSet < numberOfDataSets;
		}

		public DataSet next() {
			DataSet dataSet = new DataSet();
			dataSet.number = ++indexOfCurrentDataSet;
			dataSet.c = sc.nextDouble();
			dataSet.f = sc.nextDouble();
			dataSet.x = sc.nextDouble();
			nextLine();
			return dataSet;
		}

		private void nextLine() {
			sc.nextLine();
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
