package mp.kotter.challenges.gcj.qualification;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import mp.kotter.challenges.gcj.qualification.GarbledEmail.Index.FindResult;
import mp.kotter.challenges.utils.LineCaseSolution;

import org.apache.commons.io.IOUtils;

public class GarbledEmail extends LineCaseSolution {
    public static final int MIN_DISTANCE = 5;

    public static void main(final String[] args) throws Exception {
        (new GarbledEmail()).run(args);
    }

    private static final Index INDEX = new Index("C:\\Users\\tykhansk\\Downloads\\garbled_email_dictionary.txt");

    @Override
    protected String solveLine(final String line) {
        return "" + findMin(line);
    }

    private int findMin(final String line) {
        final Map<String, Integer> cache = new HashMap<String, Integer>();
        cache.put(getCacheKey(0, 0), 0);
        for(int offset = 0; offset < line.length(); offset ++) {
            for(int toChange = 0; toChange <= MIN_DISTANCE; toChange++) {
                expand(line, offset, toChange, cache);
            }
        }
        int minChange = Integer.MAX_VALUE;
        for(int toChange = 0; toChange <= MIN_DISTANCE; toChange++) {
            final Integer min = cache.get(getCacheKey(line.length(), toChange));
            if (min != null && min < minChange) {
                minChange = min;
            }
        }
        return minChange;
    }
}
