
package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Code Jam <br />
 * Qualification Round 2010 <br />
 * Theme Park
 * 
 * @author manishmaheshwari
 * @version 1.0 May 8, 2010
 */

public class ThemePark {

	/**
	 * @param args
	 */
	public static void main ( String[] args ) throws IOException {
		ThemePark park = new ThemePark();
		FileReader input =
				new FileReader( "/Users/manishmaheshwari/Desktop/C-small.in" );
		FileWriter output =
				new FileWriter( "/Users/manishmaheshwari/Desktop/C-small.out" );
		park.run( input, output );
		input.close();
		output.close();
	}


	private void run ( FileReader input, FileWriter output ) throws IOException {
		BufferedReader reader = new BufferedReader( input );
		BufferedWriter writer = new BufferedWriter( output );
		String line = reader.readLine();
		int T = Integer.parseInt( line );
		int index = 0;
		while ( index < T && line != null ) {
			line = reader.readLine();
			if ( line != null ) {
				StringTokenizer stok = new StringTokenizer( line );
				int R = Integer.parseInt( stok.nextToken() );
				int K = Integer.parseInt( stok.nextToken() );
				int N = Integer.parseInt( stok.nextToken() );
				int[] group = new int[N];
				String groupLine = reader.readLine();
				StringTokenizer groupTok = new StringTokenizer( groupLine );
				for ( int i = 0; i < N; i++ ) {
					group[ i ] = Integer.parseInt( groupTok.nextToken() );
				}
				long earn = process( R, K, group );
				writer.write( "Case #" + (index + 1) + ": " + earn + "\n" );
				index++;
			}
		}
		if ( index != T ) {
			throw new IOException( "Error reading file." );
		}
		writer.flush();
	}


	private long process ( int R, int K, int[] group ) {
		long[] toEarn = new long[group.length];
		int[] toLast = new int[group.length];
		Arrays.fill( toLast, -1 );
		Arrays.fill( toEarn, -1 );

		long earnings = 0;
		int groupLength = group.length;
		int currentIndex = 0;
		while ( R-- > 0 ) {
			int begin = currentIndex;
			int last = -1;
			long remCap = K;
			if ( toEarn[ begin ] != -1 ) {
				earnings = earnings + toEarn[ begin ];
				currentIndex = (toLast[ begin ] + 1) % groupLength;
				continue;
			}
			while ( true ) {
				int members = group[ currentIndex ];
				if ( remCap >= members ) {
					remCap = remCap - members;
					last = currentIndex;
					if ( (last + 1) % groupLength == begin ) {
						// We have reached to the last group, cycling back.
						// Update memoir & break;
						earnings += (K - remCap);
						toEarn[ begin ] = (K - remCap);
						toLast[ begin ] = last;
						break;
					}
					else {
						currentIndex = (currentIndex + 1) % groupLength;
					}

				}
				else {
					// No more capacity
					earnings += (K - remCap);
					// Update Memoir
					toEarn[ begin ] = (K - remCap);
					toLast[ begin ] = last;
					break;
				}
			}
		}
		return earnings;
	}

}
