import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Set;


public class FairAndSquare
{
    private static String inputFile = "/Users/Abhishek/input1.txt";
    private static String outputFile = "/Users/Abhishek/output1.txt";
    private static String result = null;
    private static Set<Long> fairAndSquareSet = new HashSet<Long>();
    private static Set<Long> fairSet = new HashSet<Long>();
    
    public static void main(String[] arg) throws Exception
    {
        BufferedReader reader = new BufferedReader(new FileReader(new File(inputFile)));
        BufferedWriter writer = new BufferedWriter(new FileWriter(new File(outputFile)));
        int testCaseCount = Integer.parseInt(reader.readLine());
        
        for(int testCase=1;testCase<=testCaseCount;testCase++)
        {
            String entries[] = reader.readLine().split(" ");
            long startRange = Long.parseLong(entries[0]);
            long endRange = Long.parseLong(entries[1]);
            long sqrtStartRange = (long)Math.ceil(Math.sqrt(startRange));
            long sqrtEndRange = (long)Math.floor(Math.sqrt(endRange));
            
            long count = findCount(sqrtStartRange,sqrtEndRange);
            
            writer.write("Case #"+testCase+": "+count+"\n");
        }
        
        writer.close();
        reader.close();
    }
    
    private static long findCount(long sqrtStartRange, long sqrtEndRange)
    {
        long count=0;
        for(long number=sqrtStartRange; number<=sqrtEndRange; number++)
        {
            if(isFair(number) && isFair(number*number))
            {
                count++;
            }
        }
        
        return count;
    }
    
    private static boolean isFair(Long num)
    {
        if(fairSet.contains(num))
            return true;
        
        char[] arr = num.toString().toCharArray();
        int len = arr.length;
        for(int i=0;i<arr.length/2;i++)
        {
            if(arr[i]!=arr[len-1-i])
            {
                return false;
            }
        }

        fairSet.add(num);
        return true;
    }
}
