import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class TicTacToeTomek {

	private static final String PATH = "src\\ressources";
	private static final String PROBLEM = "A";
	private static final String VERSION = "small-attempt0"; //large
	private static final String EXT_IN = "in";
	private static final String EXT_OUT = "out";
	
	public String solve(Scanner in) {
		String[][] board = new String[4][4];
		String[] line;
		for(int row = 0; row < 4; row++) {
			line = in.next().split("");
			for(int col = 0; col < 4; col++) {
				board[row][col] = line[col+1];
			}
		}
		String test;
		for(int row = 0; row < 4; row++) {
			test = check4(board[row]);
			if(!"none".equals(test)) {
				return test + " won";
			}
		}
		for(int col = 0; col < 4; col++) {
			test = check4(board[0][col], board[1][col], board[2][col], board[3][col]);
			if(!"none".equals(test)) {
				return test + " won";
			}
		}
		test = check4(board[0][0], board[1][1], board[2][2], board[3][3]);
		if(!"none".equals(test)) {
			return test + " won";
		}
		
		test = check4(board[0][3], board[1][2], board[2][1], board[3][0]);
		if(!"none".equals(test)) {
			return test + " won";
		}
		
		for(int row = 0; row < 4; row++) {
			for(int col = 0; col < 4; col++) {
				if(".".equals(board[row][col])) {
					return "Game has not completed";
				}
			}
		}
		
		return "Draw";
	}
	
	private String check4(String a, String b, String c, String d) {
		return check4(new String[] {a, b, c, d});		
	}
	
	private String check4(String[] tab) {
		int nbO = 0;
		int nbX = 0;
		for(int i = 0; i < 4; i++) {
			if(".".equals(tab[i])) {
				return "none";
			} else if("O".equals(tab[i])) {
				nbO++;
				nbX = 0;
			} else if("X".equals(tab[i])) {
				nbX++;
				nbO = 0;
			} else {
				nbO++;
				nbX++;
			}
		}
		if(nbO == 4)
			return "O";
		if(nbX == 4)
			return "X";
		return "none";
	}
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(getCompletPath(EXT_IN)));
		PrintWriter out = new PrintWriter(new FileWriter(getCompletPath(EXT_OUT)));
		
		int nbTestCase = in.nextInt();
		TicTacToeTomek pb = new TicTacToeTomek();
		for(int i = 0; i < nbTestCase; i++) {
			out.println("Case #" + (i+1) + ": " + pb.solve(in));
			out.flush();
		}
		
		in.close();
		out.close();
	}
	
	private static String getCompletPath(String ext) {
		return PATH + "\\" + PROBLEM + "-" + VERSION + "." + ext;
	}
	
}
