package com.google.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class FileFixeIt {

	private int count(String s, String subStr) {
		int ind = -1;
		int count = 0;
		while( (ind = s.indexOf(subStr, ind+1)) != -1 ) {
			count ++;
		}
		return count;
	}
	
	public void solve(File inFile, File outFile) throws IOException {		 
		BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream(inFile)));
		PrintWriter w = new PrintWriter(outFile);
		int T = Integer.parseInt(r.readLine().trim());
		
		for(int t = 0; t < T; t++) {
			int totalCount = 0;
			String line = r.readLine().replaceAll("  ", " ").trim();
			String[] items = line.split(" ");
			int n = Integer.parseInt(items[0]);
			int m = Integer.parseInt(items[1]);
			Set<String> existingDirs = new TreeSet<String>();
			for(int i = 0; i < n; i++) {
				line = r.readLine();
				if (!line.endsWith("/")) {
					line += "/";
				}
				existingDirs.add(line);	
				addParents(line, existingDirs);
			}
			Set<String> dirsToCreate = new TreeSet<String>();
			for(int i = 0; i < m; i++) {
				line = r.readLine();
				if (!line.endsWith("/")) {
					line += "/";
				}
				dirsToCreate.add(line);
			}
			
			for(String dir : dirsToCreate) {
				String bestMatching = "/";
				for(String parentDir : existingDirs) {
					if (dir.startsWith(parentDir) && parentDir.length() > bestMatching.length()) {
						bestMatching = parentDir;
					}
				}
				String rest = dir.substring(bestMatching.length());
				int c = count(rest, "/");
				existingDirs.add(dir);
				addParents(dir, existingDirs);
				
				totalCount += c;
			}
			w.println(String.format("Case #%d: %d", t+1, totalCount));
		}
		w.close();
		r.close();
	}

	private void addParents(String line, Set<String> existingDirs) {
		String[] parents = line.split("/");
		for(int k = 0; k < parents.length; k++) {
			StringBuilder sb = new StringBuilder();
			for(int j = 0; j <= k; j++) {
				sb.append(parents[j]);
				sb.append("/");
				existingDirs.add(sb.toString());
			}
		}
	}

	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		FileFixeIt f = new FileFixeIt();
		File in = new File("/temp/codejam/A-small-attempt0.in");
		File out = new File("/temp/codejam/A.out");
		f.solve(in, out);
	}

}
