package qual2013;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Scanner;

public class Task1 {

    private static int checkLine(int[][] a, int i) {
        int x = a[i][0] != 3 ? a[i][0] : a[i][1];
        if (x == 0) {
            return 0;
        }
        for (int j = 0; j < 4; j++) {
            if (! (a[i][j] == 3 || a[i][j] == x)) {
                return 0;
            }
        }
        return x;
    }

    private static int checkColumn(int[][] a, int i) {
        int x = a[0][i] != 3 ? a[0][i] : a[1][i];
        if (x == 0) {
            return 0;
        }
        for (int j = 0; j < 4; j++) {
            if (! (a[j][i] == 3 || a[j][i] == x)) {
                return 0;
            }
        }
        return x;
    }

    private static int checkDiag(int[][] a) {
        int x = a[0][0] != 3 ? a[0][0] : a[1][1];
        if (x == 0) {
            return 0;
        }
        for (int j = 0; j < 4; j++) {
            if (! (a[j][j] == 3 || a[j][j] == x)) {
                return 0;
            }
        }
        return x;
    }

    private static int checkDiag1(int[][] a) {
        int x = a[0][3] != 3 ? a[0][3] : a[1][2];
        if (x == 0) {
            return 0;
        }
        for (int j = 0; j < 4; j++) {
            if (! (a[j][3 - j] == 3 || a[j][3 - j] == x)) {
                return 0;
            }
        }
        return x;
    }

    private static boolean isDraw(int[][] a) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (a[i][j] == 0) {
                    return false;
                }
            }
        }
        return true;
    }

    public static void calc(Scanner scanner, int t) {
        int[][] tictac = new int[4][4];
        for (int i = 0; i < 4; i++) {
            String s = scanner.nextLine();
            for (int j = 0; j < 4; j++) {
                char c = s.charAt(j);
                tictac[i][j] = 0;
                if (c == 'X') {
                    tictac[i][j] = 1;
                } else if (c == 'O') {
                    tictac[i][j] = 2;
                } else if (c == 'T') {
                    tictac[i][j] = 3;
                }
            }
        }
        int o = Math.max(checkDiag(tictac), checkDiag1(tictac));
        for (int i = 0; i < 4; i++) {
            o = Math.max(checkLine(tictac, i), o);
            o = Math.max(checkColumn(tictac, i), o);
        }
        if (o == 1) {
            System.out.println("Case #" + t + ": X won");
        }
        if (o == 2) {
            System.out.println("Case #" + t + ": O won");
        }
        if (o == 0) {
            if (isDraw(tictac)) {
                System.out.println("Case #" + t + ": Draw");
            } else {
                System.out.println("Case #" + t + ": Game has not completed");
            }
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner scanner = new Scanner(new FileInputStream("task21.txt"));
        int T = scanner.nextInt();
        scanner.nextLine();
        for (int i = 0; i < T; i++) {
            calc(scanner, i + 1);
            scanner.nextLine();
        }
    }
}
