/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package snapper.chain;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Aaron
 */
public class SnapperChain {

    private int n;
    private Snapper[] snappers;

    class Snapper {

        private boolean powerIn;
        private boolean state;

        public Snapper() {
            powerIn = false;
            state = false;
        }

        public Snapper(boolean powerIn) {
            this.powerIn = powerIn;
            state = false;
        }

        public void toggleState(boolean powerIn) {
            if (this.powerIn == true) {
                state = !state;
            }
            this.powerIn = powerIn;
        }

        public boolean getPowerOut() {
            return (powerIn && state);
        }
    }

    public SnapperChain(int n) {
        this.n = n;
        snappers = new Snapper[n];
        for (int i = 0; i < n; i++) {
            if (i == 0) {
                snappers[i] = new Snapper(true);
                continue;
            }
            snappers[i] = new Snapper();
        }
    }

    public void toggleStates() {
        for (int i = 0; i < n; i++) {
            if (i == 0) {
                snappers[i].toggleState(true);
                continue;
            }
            snappers[i].toggleState(snappers[i - 1].getPowerOut());
        }
    }

    public String getLightState() {
        if (snappers[n - 1].getPowerOut() == true) {
            return "ON";
        }
        return "OFF";
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        try {
            BufferedReader br = new BufferedReader(new FileReader("A-small.in"));
            FileWriter fw = new FileWriter("A-small.out", false);
            int cases_count = Integer.parseInt(br.readLine());
            for (int i = 0; i < cases_count; i++) {
                String[] values = br.readLine().split(" ");
                SnapperChain snapperChain = new SnapperChain(Integer.parseInt(values[0]));
                int k = Integer.parseInt(values[1]);
                for (int j = 0; j < k; j++) {
                    snapperChain.toggleStates();
                }
                fw.write("Case #" + (i + 1) + ": " + snapperChain.getLightState() + "\n");
            }
            br.close();
            fw.close();
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
