import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.LinkedList;



enum Robot {
	Blue,
	Orange
}

class SequenceElement {
	final Robot r;
	final int position;
	
	public SequenceElement(Robot r, int position) {
		this.r = r;
		this.position = position;
	}
}

public class BotTrust {

	public static void main(String[] args) {
		
		try {
			String inFileName = args[0];
			BufferedReader in = new BufferedReader(new FileReader(inFileName));
			BufferedWriter out = new BufferedWriter(new FileWriter(inFileName + ".out"));
			int testCases = Integer.parseInt(in.readLine());

			for (int caseNo = 1; caseNo <= testCases; ++caseNo) {
				String[] sequenceStr = in.readLine().split(" ");
				LinkedList<SequenceElement> sequence = new LinkedList<SequenceElement>();
				
				for (int i = 1; i < sequenceStr.length; i += 2) {
					String robot = sequenceStr[i];
					int position = Integer.parseInt(sequenceStr[i + 1]);
					sequence.add(new SequenceElement(robot.equals("O") ? Robot.Orange : Robot.Blue, position));
				}
				
				Iterator<SequenceElement> it = sequence.iterator();
				int time = 0;
				int blueTime = 0;
				int orangeTime = 0;
				int bluePosition = 1;
				int orangePosition = 1;
				
				while (it.hasNext()) {
					SequenceElement e = it.next();
					++time;
					
					int distance = 0;
					
					if (e.r == Robot.Orange) {
						distance = Math.abs(orangePosition - e.position);
						distance = Math.max(0, distance - orangeTime);
						orangeTime = 0;
						orangePosition = e.position;
						blueTime += 1 + distance;
					} else {
						distance = Math.abs(bluePosition - e.position);
						distance = Math.max(0, distance - blueTime);
						blueTime = 0;
						bluePosition = e.position;
						orangeTime += 1 + distance;
					}
					
					time += distance;
				}
				
				String caseResultStr = "Case #" + caseNo + ": " + time + "\n";
				System.out.print(caseResultStr);
				out.write(caseResultStr);
				out.flush();
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

}
