import java.io.*;
import java.util.StringTokenizer;

public class CandySplitting
{
	public static void main( String[] args ) throws IOException
	{
		StringTokenizer line;
		BufferedReader br = null;
		PrintWriter pw = null;
		if( args.length >= 2 )
		{
			FileReader fr = new FileReader( args[0] );
			br = new BufferedReader(fr);
			
			FileWriter fw = new FileWriter( args[1] );
			pw = new PrintWriter(fw);
		}
		else
		{
			System.exit(0);
		}
		
		int n;	
		
		int testCases = Integer.parseInt(br.readLine());
		for( int i=0; i<testCases; i++ )
		{

			n = Integer.parseInt( br.readLine() );
			int[] vals = new int[n];
			
			line = new StringTokenizer( br.readLine() );
			for( int j=0; j<n; j++ )
				vals[j] = Integer.parseInt( line.nextToken() ); 
			int sMax = -1;
			
			int cMax = (int)(Math.pow( 2, n ))-1;
			
			for( int j=1; j<cMax; j++ )	/* skip 0 and n-1 */
			{
				if( compare( j, vals ) )
				{
					int sVal = getSVal( j, vals );
					if( sVal > sMax )
						sMax = sVal;
				}
			}
			if( sMax != -1 )
				pw.print("Case #" + (i+1) + ": " + sMax + "\n" );
			else
				pw.print("Case #" + (i+1) + ": " + "NO" + "\n" );
		}
		pw.close();
		br.close();
	}
	public static int getSVal( int s, int[] vals )
	{
		int total = 0;
		int idx = 0;
		int i = 0;
		while( idx < vals.length )
		{
			if( s % 2 == 1 )
				total += vals[idx];
			s /= 2;
			idx++;
		}
		return total;
	}
	public static boolean compare( int p, int[] vals )
	{	
		int total = 0;
		int total2 = 0;
		int idx= 0;
		int p2 = p;
		while( idx < vals.length )
		{
			if( p % 2 == 0 )
			{
				total = xor( total, vals[idx] );
			}
			p /= 2;
			idx++;
		}
		idx= 0;
		p = p2;
		while( idx < vals.length )
		{
			if( p % 2 == 1 )
			{
				total2 = xor( total2, vals[idx] );
			}
			p /= 2;
			idx++;
		}
		return total == total2;
	}
	public static int xor( int a, int b )
	{
		int total = 0;
		int bitVal = 1;
		int i;
		int r = 0;
		for( i=0; i<16; i++ )
		{
			if( a%2 != b%2 )
				total += bitVal;
			bitVal *= 2;
			a /= 2;
			b /= 2;
		}
		return total;
	}
}