import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.StringTokenizer;


public class BotTrust {
	public static void main(String[] args) {
		Scanner inputStream = new Scanner(System.in);
		int n = Integer.parseInt(inputStream.nextLine());
		
		for (int i = 0; i < n; i++) {
			String input = inputStream.nextLine();
			StringTokenizer st = new StringTokenizer(input);
			
			int p = Integer.parseInt(st.nextToken());
			
			List <Integer> bluePositions = new ArrayList <Integer>();
			List <Integer> orangePositions = new ArrayList <Integer>();
			boolean[] blueTurns = new boolean[p];
			
			for (int j = 0; j < p; j++) {
				String nextColor = st.nextToken();
				int nextPosition = Integer.parseInt(st.nextToken());
				
				blueTurns[j] = nextColor.equals("B");
				if (blueTurns[j]) {
					bluePositions.add(nextPosition);
				} else {
					orangePositions.add(nextPosition);
				}
			}
			
			int orangePosition = 1, bluePosition = 1;
			int orangeIndex = 0, blueIndex = 0;
			int totalCost = 0;
			
			for (int j = 0; j < p; j++) {
				if (blueTurns[j]) {
					int numMoves = Math.abs(bluePositions.get(blueIndex) - bluePosition) + 1;
					bluePosition = bluePositions.get(blueIndex++);
					
					if (orangeIndex < orangePositions.size()) {
						int requiredMoves = Math.abs(orangePositions.get(orangeIndex) - orangePosition);
						if (requiredMoves < numMoves) {
							orangePosition = orangePositions.get(orangeIndex);
						} else {
							orangePosition += numMoves * (orangePositions.get(orangeIndex) > orangePosition ? 1 : -1);
						}
					}
					
					totalCost += numMoves;
				} else {
					int numMoves = Math.abs(orangePositions.get(orangeIndex) - orangePosition) + 1;
					orangePosition = orangePositions.get(orangeIndex++);
					
					if (blueIndex < bluePositions.size()) {
						int requiredMoves = Math.abs(bluePositions.get(blueIndex) - bluePosition);
						if (requiredMoves < numMoves) {
							bluePosition = bluePositions.get(blueIndex);
						} else {
							bluePosition += numMoves * (bluePositions.get(blueIndex) > bluePosition ? 1 : -1);
						}
					}
					
					totalCost += numMoves;
				}
			}
			
			System.out.println("Case #" + (i + 1) + ": " + totalCost);
		}
	}
}
