package de.stefanBirkner;

import static java.lang.Integer.parseInt;
import static org.apache.commons.io.IOUtils.readLines;

import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;

public class DataSetParser {
	public static String[][][] readDataSetFromResource(String name)
	throws IOException {
		Iterator<String> lines = readLinesFromResource(name);
		return readRawDataSetsForTest(lines);
	}

	private static Iterator<String> readLinesFromResource(String name)
			throws IOException {
		InputStream is = DataSetParser.class.getResourceAsStream(name);
		return (Iterator<String>) readLines(is).iterator();
	}

	private static int readLineWithSingleInteger(Iterator<String> lines) {
		return parseInt(lines.next());
	}

	private static int[][] readDataSetsForTest(Iterator<String> lines) {
		int numDataSets = readLineWithSingleInteger(lines);
		int[][] datasets = new int[numDataSets][];
		for (int i = 0; i < numDataSets; i++) {
			datasets[i] = readDataSet(lines);
		}
		return datasets;
	}

	private static int[] readDataSet(Iterator<String> lines) {
		String line = lines.next();
		String[] valuesAsString = line.split(" ");
		int[] dataSet = new int[valuesAsString.length];
		for (int i = 0; i < valuesAsString.length; i++) {
			String string = valuesAsString[i];
			dataSet[i] = parseInt(string);
		}
		return dataSet;
	}

	private static String[][][] readRawDataSetsForTest(Iterator<String> lines) {
		int numDataSets = readLineWithSingleInteger(lines);
		String[][][] datasets = new String[numDataSets][][];
		for (int i = 0; i < numDataSets; i++) {
			datasets[i] = readRawDataSet(lines);
		}
		return datasets;
	}

	private static String[][] readRawDataSet(Iterator<String> lines) {
		String[] numbers = lines.next().split(" ");
		int sizeDictionary = Integer.parseInt(numbers[0]);
		String[] dictionary = new String[sizeDictionary];
		for (int i = 0; i < dictionary.length; i++) {
			dictionary[i] = lines.next();
		}
		int numLists = Integer.parseInt(numbers[1]);
		String[] lists = new String[numLists];
		for (int i = 0; i < lists.length; i++) {
			lists[i] = lines.next();
		}
		return new String[][] {dictionary, lists};
	}
}
