import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.LinkedList;

public class A {
    private static final String CHEAT = "Volunteer cheated!";
    private static final String BAD = "Bad magician!";

    private static String getAnswer(String[] rowCards1, String[] rowCards2) {
        LinkedList<String> possibleCards = new LinkedList<>();

        for (int i = 0; i < rowCards1.length; i++) {
            for (int j = 0; j < rowCards2.length; j++) {
                if (rowCards1[i].equals(rowCards2[j])) {
                    possibleCards.add(rowCards1[i]);
                }
            }
        }

        if (possibleCards.size() == 1) {
            return possibleCards.getFirst();
        } else if (possibleCards.size() > 1) {
            return BAD;
        } else {
            return CHEAT;
        }
    }

    private static String[] getPossibleCards(BufferedReader br)
            throws IOException {
        String[] cards = null;
        String line = null;

        // Read line containing card row
        line = br.readLine();
        int cardLine = Integer.valueOf(line);

        // Read row containing card
        for (int i = 1; i <= 4; i++) {
            line = br.readLine();
            if (i == cardLine) {
                cards = line.split(" ");
            }
        }

        return cards;
    }

    private static String processCaseInput(BufferedReader br)
            throws IOException {
        String[] rowCards1 = getPossibleCards(br);
        String[] rowCards2 = getPossibleCards(br);

        return getAnswer(rowCards1, rowCards2);
    }

    public static void main(String[] args) {
        int numCases = 0;

        if (args.length != 1) {
            System.err.println("Input file required for processing");
            System.exit(0);
        }

        // Create the output file
        File outputFile = new File("output.out");
        if (!outputFile.exists()) {
            try {
                outputFile.createNewFile();
            } catch (IOException e) {
                e.printStackTrace();
                System.exit(0);
            }
        }

        // Read input
        try (FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
                BufferedWriter bw = new BufferedWriter(fw);
                BufferedReader br = new BufferedReader(new FileReader(args[0]));) {

            // First line should contain the number of test cases
            String line = br.readLine();
            numCases = Integer.parseInt(line);

            long startTime = System.currentTimeMillis();

            // Following lines should contain test cases
            for (int i = 1; i <= numCases && line != null; i++) {
                String caseAnswer = processCaseInput(br);
                String outputLine = "Case #" + i + ": " + caseAnswer;
                System.out.println(outputLine);
                bw.write(outputLine + "\n");
            }

            long endTime = System.currentTimeMillis();
            System.out.println("Execution time = " + (endTime - startTime));
        } catch (IOException e) {
            System.out.println("Input file not found!");
            e.printStackTrace();
        }
    }
}