import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;


public class TicTacToe {
    private static String inputFile = "/Users/Abhishek/input.txt";
    private static String outputFile = "/Users/Abhishek/output.txt";
    private static String result = null;
    public static void main(String[] arg) throws Exception
    {
        BufferedReader reader = new BufferedReader(new FileReader(new File(inputFile)));
        BufferedWriter writer = new BufferedWriter(new FileWriter(new File(outputFile)));
        int testCaseCount = Integer.parseInt(reader.readLine());
        
        for(int testCase=1;testCase<=testCaseCount;testCase++)
        {
            char[][] matrix = new char[4][4];
            result = null;
            String rowEntry = reader.readLine();
            processLine(matrix, 0, rowEntry,testCase);

            rowEntry = reader.readLine();
            processLine(matrix, 1, rowEntry,testCase);

            rowEntry = reader.readLine();
            processLine(matrix, 2, rowEntry,testCase);

            rowEntry = reader.readLine();
            processLine(matrix, 3, rowEntry,testCase);
            
            processColumnsAndDiagonals(matrix,testCase);
            
            if(result==null)
            {
                result = "Case #"+testCase+": Draw";
            }
            
            writer.write(result+"\n");
            reader.readLine();
        }
        
        writer.close();
        reader.close();
                
    }
    
    private static void processLine(char[][] matrix, int row, String entry, int testCaseNumber)
    {
        if(result!=null)
        {
            return;
        }
        
        int col=0;
        boolean isAllX=true;
        boolean isAllY=true;
        for(char c:entry.toCharArray())
        {
            matrix[row][col++]=c;
            if(isAllX && c!='X' && c!='T')
                isAllX=false;

            if(isAllY && c!='O' && c!='T')
                isAllY=false;            
        }
        
        if(isAllX)
        {
            result = "Case #"+testCaseNumber+": X won";
            return;
        }
        else if(isAllY)
        {
            result = "Case #"+testCaseNumber+": O won";
            return;
        }
    }
            

}
