/**
 * @author Maxim Degtyarev <mdegtyarev@gmail.com>
 */
import java.io.*;
import java.util.*;

public class ProblemB {

    private final Scanner input;
    private final PrintStream output;

    private String solveCase() {

		int A = input.nextInt();
		int B = input.nextInt();
		int K = input.nextInt();

		int result = 0;

		for(int ia = 0; ia < A; ia++) {
			for(int ib = 0; ib < B; ib++) {
				int value = ia & ib;
				if (value < K) result++;
			}
		}

		return Integer.toString(result);
    }

    private void invoke() {
        int caseCount = input.nextInt();

        String rest = input.nextLine();

        assert rest.length() == 0 : rest;

        String result;
        for(int caseNumber = 1; caseNumber <= caseCount; caseNumber++) {
            result = solveCase();
            output.printf("Case #%d: %s\n", caseNumber, result);
        }        
    }
    
    private ProblemB(InputStream input, PrintStream output) {
        this.input = new Scanner(input);
        this.output = output;
    }     
    
    public static void main(String... args) throws FileNotFoundException {

        InputStream inputStream;
        PrintStream outputStream;
        
        if (args.length > 0) {
            
            final String inputFileName = args[0];
            final String outputFileName;
            
            if (inputFileName.endsWith(".in")) {
                outputFileName = inputFileName.substring(0, inputFileName.length() - 3) + ".out";
            } else {
                outputFileName = inputFileName + ".out";
            }

            inputStream = new FileInputStream(inputFileName);
            outputStream = new PrintStream(outputFileName);

        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        
        ProblemB instance = new ProblemB(inputStream, outputStream);
        
        instance.invoke();        
    }

}
