import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.Locale;
import java.util.TreeMap;
import java.util.TreeSet;

class Interval {
	final long length;
	final long velocity;
	
	Interval(long length, long velocity) {
		this.length = length;
		this.velocity = velocity;
	}
}

public class CodeJam {
	

	public static void main(String[] args) throws IOException {
		
		String inFileName = args[0];
		BufferedReader in = new BufferedReader(new FileReader(inFileName));
		BufferedWriter out = new BufferedWriter(new FileWriter(inFileName + ".out"));
		int testCases = Integer.parseInt(in.readLine());

		for (int caseNo = 1; caseNo <= testCases; ++caseNo) {
			String caseStr[] = in.readLine().split(" ");
			final int R = Integer.parseInt(caseStr[0]);
			final int C = Integer.parseInt(caseStr[1]);
			final int D = Integer.parseInt(caseStr[2]);
			long[][] xy = new long[C][R];
			
			for (int y = 0; y < R; ++y) {
				String c = in.readLine();
				for (int x = 0; x < C; ++x) {
					xy[x][y] = c.charAt(x) - '0';
				}
			}
			
			Integer bladeSize = null;
			
			for (int size = Math.min(R, C); size >= 3 && bladeSize == null; --size) {
				for (int sx = 0; sx <= C - size && bladeSize == null; ++sx) {
					for (int sy = 0; sy <= R - size; ++sy) {
						long xCenter = 0;
						long yCenter = 0;
						long centerX = 2 * sx + size;
						long centerY = 2 * sy + size;
						
						for (int x = sx; x < sx + size; ++x) {
							for (int y = sy; y < sy + size; ++y) {
								if (x == sx && y == sy) {
									continue;
								}
								
								if (x == sx + size - 1 && y == sy) {
									continue;
								}
								
								if (x == sx + size - 1 && y == sy + size - 1) {
									continue;
								}
								
								if (x == sx && y == sy + size - 1) {
									continue;
								}
								
								long rx = 1 + 2 * x - centerX;
								xCenter += rx * (xy[x][y] + D);
								
								long ry = 1 + 2 * y - centerY;
								yCenter += ry * (xy[x][y] + D);
							}
						}
						
						if (xCenter == 0 && yCenter == 0) {
							bladeSize = size;
							break;
						}
					}
				}
			}
			
			StringBuilder result = new StringBuilder();
			result.append(bladeSize == null ? "IMPOSSIBLE" : bladeSize.toString());
			
			final String resultStr = "Case #" + caseNo + ": " + result.toString() + "\n";
			out.write(resultStr);
			System.out.print(resultStr);
			out.flush();
		}
	}
}
