package bottrust;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.Iterator;


public class BotTrust {
	private String outFile = null;
	private ArrayList<BotTrustTask> tasks = new ArrayList<BotTrustTask>();	
	
	public BotTrust(String outFile){
		this.outFile = outFile;
	}
		
	public boolean readInputFile(String file){
		int numEntries = 0;
		BufferedReader br =null;
		String line = "";
		try {
			br = new BufferedReader(new FileReader(new File(file)));
			numEntries = new Integer(br.readLine());
			System.out.println(numEntries);
			String botTaskString = "";
			for(int i=0;i<numEntries;i++){
				BotTrustTask btt = new BotTrustTask();
				botTaskString = br.readLine();
				StringTokenizer tokenizer = new StringTokenizer(botTaskString);
				int numPush = new Integer(tokenizer.nextToken());
				String botColor = "";
				for(int j=0;j<numPush;j++){
					botColor = tokenizer.nextToken();
					if(botColor.equals("O")){
						btt.addOrange(new Integer(tokenizer.nextToken()));
					}else{
						btt.addBlue(new Integer(tokenizer.nextToken()));
					}
				}
				this.tasks.add(btt);
			}
			br.close();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
			return false;
		}
		return true;
	}
	
	public void solveTasks(){
		Iterator<BotTrustTask> iter = this.tasks.iterator();
		String result = "";		
		int count = 1;
		int cnt2 = 1;
		while(iter.hasNext()){
			//System.out.println("RESULT:");			
			result += "Case #" + count++ + ": ";
			result += iter.next().solveTask() + "\n";
			/*if(cnt2++==100){
				System.out.println(count);
				cnt2 = 1;
			}*/
			///System.out.println(result);
		}
		saveResult(result);
		System.out.println("RESULT:");
		System.out.println(result);		
	}
		
	private void saveResult(String result){
		
		try {
			FileWriter fw = new FileWriter(outFile);
			BufferedWriter out = new BufferedWriter(fw);
		    out.write(result);
		    out.close();
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
		}
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		BotTrust bt = new BotTrust(args[1]);
		bt.readInputFile(args[0]);
		bt.solveTasks();
		System.exit(0);
	}


}
