import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.Arrays;


public class ProblemC {

	public static void main(String[] args) {
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				Thread.currentThread().getContextClassLoader().getResourceAsStream("C-small-attempt0.in")));
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new OutputStreamWriter(
			          new FileOutputStream("output.txt"), "utf-8"));
		} catch (UnsupportedEncodingException | FileNotFoundException e1) {
			e1.printStackTrace();
			System.exit(0);
		}
		try {
			int T = Integer.parseInt(reader.readLine());
			for(int times = 1; times<=T; times++) {		
				String[] values = (reader.readLine()).split(" ");
				int R = Integer.parseInt(values[0]);
				int C = Integer.parseInt(values[1]);
				int M = Integer.parseInt(values[2]);
				boolean impossible = false;
				char[][] grid = new char[R][C];
				for(int i=0;i<R;i++) Arrays.fill(grid[i], '.');
				
				if(R==1 && C==1) {
					if(M!=0) impossible = true;
					else grid[0][0] = 'c';
				}
				else if(R==1 && C>1) {
					if(M<C) {
						for(int i=0;i<M;grid[0][i++]='*');
						grid[0][C-1] = 'c';
					}
					else impossible = true;
				}
				else if(R>1 && C==1) {
					if(M<R) {
						for(int i=0;i<M;grid[i++][0]='*');
						grid[R-1][0] = 'c';
					}
					else impossible = true;
				}
				else {
					if(M == (R*C - 1)) {
						for(int i=0;i<R;i++) Arrays.fill(grid[i], '*');
						grid[R-1][C-1] = 'c';
					}
					else if(R==2){
						if(M<=(R*C - 4) && M%2==0) {
							for(int i=0; i<(M/2); i++) {
								grid[0][i] = grid[1][i] = '*';
							}
							grid[1][C-1] = 'c';
						}
						else impossible = true;
					}
					else if(C==2) {
						if(M<=(R*C - 4) && M%2==0) {
							for(int i=0; i<(M/2); i++) {
								grid[i][0] = grid[i][1] = '*';
							}
							grid[R-1][1] = 'c';
						}
						else impossible = true;
					}
					else {
						if(M <= ( (R*C) - (2*(R+C-2)) )) {
							for(int i=0; i<(R-2) && M>0; i++) {
								for(int j=0; j<(C-2) && M>0; j++) {
									grid[i][j] = '*';
									M--;
								}
							}
							grid[R-1][C-1] = 'c';
						}
						else impossible = true;
					}
				}
				
				writer.write("Case #"+times+":\n");
				if(impossible)
					writer.write("Impossible\n");
				else {
					for(int i=0; i<R; i++) {
						for(int j=0; j<C; j++) {
							writer.write(grid[i][j]);
						}
						writer.write("\n");
					}
				}
			}
		} catch (IOException e) {
			System.out.println("IOException while reading input file.");
			e.printStackTrace();
			System.exit(0);
		}
		finally {
			try {
				reader.close();
				writer.close();
			} catch (IOException e) {
				System.out.println("IOException while trying to close input/output file.");
				e.printStackTrace();
			}
		}
	}

}
