import java.util.Vector;
import java.util.Scanner;
import java.util.PriorityQueue;

public class Question2 {

	private static Scanner sc = new Scanner(System.in);
	
	private void start() {
		int iterations = sc.nextInt();
		for(int i = 0; i < iterations; ++i) {
			System.out.print("Case #" + (i+1) + ": ");
			solveQ2();
		}
	}
	
	private PriorityQueue<Trip> getJobs(int jobs) {
		
		PriorityQueue<Trip> ret = new PriorityQueue<Trip>();
		for(int i = 0; i < jobs; ++i) {
			String[] split = sc.next().split(":");
			Time from = new Time(Integer.parseInt(split[0]), Integer.parseInt(split[1]));
			split = sc.next().split(":");
			Time to = new Time(Integer.parseInt(split[0]), Integer.parseInt(split[1]));
			ret.add(new Trip(from, to));
		}
		return ret;
	}
	
	private void solveQ2() {
		int turnAroundTime = sc.nextInt();
		
		int numLeft = sc.nextInt();
		int numRight = sc.nextInt();
		
		PriorityQueue<Trip> jobsLeft = getJobs(numLeft);
		PriorityQueue<Trip> jobsRight = getJobs(numRight);
		
		
		int needLeft = 0;
		PriorityQueue<Time> trainsLeft = new PriorityQueue<Time>();
		int needRight = 0;
		PriorityQueue<Time> trainsRight = new PriorityQueue<Time>();
		
		while (!jobsLeft.isEmpty() || !jobsRight.isEmpty()) {
			while(!jobsLeft.isEmpty() && jobsLeft.peek().compareTo(jobsRight.peek()) <= 0) {
				if(trainsLeft.peek()!=null&&trainsLeft.peek().compareTo(jobsLeft.peek().from)<=0) {
					//System.out.println("Train left to right: " + jobsLeft.peek());
					trainsRight.add(jobsLeft.peek().to.add(turnAroundTime));
					trainsLeft.poll();
					jobsLeft.poll();
				} else {
					//System.out.println("Adding train on the left.");
					trainsLeft.add(new Time(0,0));
					needLeft++;
				}
			}
			while(!jobsRight.isEmpty()&& jobsRight.peek().compareTo(jobsLeft.peek()) <= 0) {
				if(trainsRight.peek()!=null&&trainsRight.peek().compareTo(jobsRight.peek().from)<=0) {
					//System.out.println("Train right to left: " + jobsRight.peek());
					trainsLeft.add(jobsRight.peek().to.add(turnAroundTime));
					jobsRight.poll();
					trainsRight.poll();
				} else {
					//System.out.println("Adding train on the Right.");
					trainsRight.add(new Time(0,0));
					needRight++;
				}
			}
		}
		System.out.println(needLeft + " " + needRight);
	}
	
	public static void main(String[] args) {
		(new Question2()).start();
	}
	
	private class Time implements Comparable<Time> {
		private int hour;
		private int minute;
		public Time(int hours, int minutes) {
			hour = hours;
			minute = minutes;
		}
		public Time add(int minutes) {
			return new Time(hour + (minute+minutes)/60, (minute+minutes)%60);
		}
		public int compareTo(Time t) {
			if (t == null) return -1;
			if(hour != t.hour) return hour - t.hour;
			else return minute - t.minute;
		}
		public String toString() {
			return hour + ":" + minute;
		}
	}
	private class Trip implements Comparable<Trip> {
		Time from;
		Time to;
		public Trip(Time from, Time to) {
			this.from = from;
			this.to = to;
		}
		public int compareTo(Trip t) {
			if (t == null) return -1;
			else return from.compareTo(t.from);
		}
		public String toString() {
			return "From: " + from.toString() + ", to: " + to.toString();
		}
	}
}
