import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Lawnmower {
	private static final int minHeight = 1;
	private static final int maxHeight = 100;

	private static String process(int[][] lawn) {
		int length = lawn.length;
		int width = lawn[0].length;

		// Print lawn for debugging
//		for (int i = 0; i < lawn.length; i++) {
//			for (int j = 0; j < lawn[i].length; j++) {
//				System.out.print(lawn[i][j] + " ");
//			}
//			System.out.println();
//		}

		// Check each lawn section
		for (int i = 0; i < length; i++) {
			for (int j = 0; j < width; j++) {
				int height = lawn[i][j];

				// Make sure the height is valid
				if (height < minHeight || height > maxHeight) {
					return "NO";
				}

				// height cannot be less than outer sections
				boolean shorterThanRow = false;
				boolean shorterThanColumn = false;

				// Check rows in each direction
				int iPos, jPos;

				// Scan up
				jPos = j;
				while (jPos >= 0) {
					if (height < lawn[i][jPos]) {
						shorterThanRow = true;
						break;
					}
					jPos--;
				}

				// Scan down
				if (!shorterThanRow) {
					jPos = j;
					while (jPos < width) {
						if (height < lawn[i][jPos]) {
							shorterThanRow = true;
							break;
						}
						jPos++;
					}
				}

				// Scan left
				iPos = i;
				while (iPos >= 0) {
					if (height < lawn[iPos][j]) {
						shorterThanColumn = true;
						break;
					}
					iPos--;
				}

				// Scan right
				if (!shorterThanColumn) {
					iPos = i;
					while (iPos < length) {
						if (height < lawn[iPos][j]) {
							shorterThanColumn = true;
							break;
						}
						iPos++;
					}
				}

				
				if (shorterThanRow && shorterThanColumn) {
					return "NO";
				}
			}
		}

		return "YES";
	}

}
