import java.io.*;
import java.util.*;
import static java.lang.Math.*;
import static java.lang.System.*;
import static java.util.Collections.*;

public class CandySplitting {
	
	static Scanner pause = new Scanner(System.in);
	
	public static void main(String args[]) throws IOException {
		
		File in = new File("f:\\programs\\googlecodejam\\CandySplitting.in");
		File o = new File("f:\\programs\\googlecodejam\\CandySplitting.out");
		Scanner scan = new Scanner(in);
		FileWriter output = new FileWriter(o);
		int n = scan.nextInt(), temp=0;
		String res = "";
		scan.nextLine();
		
		
		for(int i=0; i<n; i++) {
			int m = scan.nextInt();
			int[] candy = new int[m];
			ArrayList<Integer> excluded = new ArrayList(), included = new ArrayList();
			for(int j=0; j<m; j++)
				candy[j] = scan.nextInt();
			temp = candyCounter(candy, included, excluded, 0);
			res += "Case #" + (i+1) + ": " + (temp==-1?"NO":temp) + "\n";
		}
		output.write(res);
		output.close();
	}
	
	public static int candyCounter(int[] candy, ArrayList<Integer> included, ArrayList<Integer> excluded, int pos) {
		
		if(pos == candy.length) {
			if(fakeSum(included) == fakeSum(excluded) && included.size() > 0 && excluded.size() > 0)
				return max(realSum(included), realSum(excluded));
			return -1;
		}
		else {
			int res = -1;
			if(fakeSum(included) == fakeSum(excluded) + fakeSum(candy, pos) && included.size() > 0)
				res = max(realSum(included), realSum(excluded));
				
			included.add(candy[pos]);
			res = max(candyCounter(candy, included, excluded, pos+1), res);
			included.remove(included.size()-1);
			
			excluded.add(candy[pos]);
			res = max(candyCounter(candy, included, excluded, pos+1), res);
			excluded.remove(excluded.size()-1);
			
			//System.out.printf("END %s %s\n%d %d\n\n", included.toString(), excluded.toString(), pos, res);
			return res;
		}
	}
	
	public static int fakeSum(int[] candy, int pos) {
		
		int res = 0;
		for(int i=pos; i<candy.length; i++)
			res = res ^ candy[i];
		return res;
	}
	
	public static int fakeSum(ArrayList<Integer> candy) {
		
		int res = 0;
		for(Integer i : candy)
			res = res ^ i;
		return res;
	}
	
	public static int realSum(ArrayList<Integer> candy) {
		
		int res = 0;
		for(Integer i : candy)
			res = res + i;
		return res;
	}
}