package minesweeper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class MinesweeperSolver {

	static class MinesweeperModel {
		int R_row;
		int C_column;
		int M_mines;
	}

	static MinesweeperModel[] readInputs(String path) throws IOException {
		InputStream ips = new FileInputStream(path);
		InputStreamReader ipsr = new InputStreamReader(ips);
		BufferedReader br = new BufferedReader(ipsr);
		String ligne;

		ligne = br.readLine();
		int casesCount = Integer.parseInt(ligne);
		MinesweeperModel[] arrayModels = new MinesweeperModel[casesCount];

		for (int c = 0; c < casesCount; c++) {
			arrayModels[c] = new MinesweeperModel();
			ligne = br.readLine();
			StringTokenizer tokenizer = new StringTokenizer(ligne);
			arrayModels[c].R_row = Integer.parseInt(tokenizer.nextToken());
			arrayModels[c].C_column = Integer.parseInt(tokenizer.nextToken());
			arrayModels[c].M_mines = Integer.parseInt(tokenizer.nextToken());
		}

		br.close();
		return arrayModels;
	}

}
