package qr2014;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class CookieClickerAlpha {
	private static final String PATH = "src\\ressources";
	private static final String PROBLEM = "B";
	private static final String VERSION = "small-attempt0";//"small-attempt0"; //large
	private static final String EXT_IN = "in";
	private static final String EXT_OUT = "out";
	
	public String solve(Scanner in) {
		double farmCost = in.nextDouble();
		double farmBonus = in.nextDouble();
		double goal = in.nextDouble();
		
		double cookiesPerSec = 2f;
		double totalTime = 0f;
		
		while((farmCost / cookiesPerSec) + (goal  / (cookiesPerSec + farmBonus)) < goal / cookiesPerSec) {
			totalTime += farmCost / cookiesPerSec;
			cookiesPerSec += farmBonus;
		}
		totalTime += goal / cookiesPerSec;
		
		return String.valueOf(totalTime);
	}
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(getCompletPath(EXT_IN)));
		in.useLocale(Locale.US);
		PrintWriter out = new PrintWriter(new FileWriter(getCompletPath(EXT_OUT)));
		
		int nbTestCase = in.nextInt();
		CookieClickerAlpha cca = new CookieClickerAlpha();
		for(int i = 0; i < nbTestCase; i++) {
			out.println("Case #" + (i+1) + ": " + cca.solve(in));
			out.flush();
		}
		
		in.close();
		out.close();
	}
	
	private static String getCompletPath(String ext) {
		return PATH + "\\" + PROBLEM + "-" + VERSION + "." + ext;
	}
}
